<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com           deuslatinum@web.de    |
   //          '.'.J                         ICQ:147326489                    |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This script will configure your gallery and will      *|
 \*                   include all needed functions                          *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 27.04.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: common.inc.php                               |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/


################################################################################
######################## please do not change anything! ########################
################################################################################

##### include all needed functions
include_once("./functions.inc.php");

##### for execution time
$starttime = timestop();

##### configuration
include_once("./config.ini");

##### stop notice messages
@error_reporting(E_ALL ^ E_NOTICE);

##### version of the gallery
$version = "2.0";

##### built of this gallery
$_built = "2.0.01";

##### update server
$update_server = "http://www.fabian-schneider.com/update/index.php?prog=gal";

##### path for all needed data; with slash!
$data_path = "./data/";

##### path for all installed plugins; with slash!
$plugin_path = "./plugins/";

##### path with the database information and also the categories; with slash!
$gallery_path = $data_path."db/";

##### path with all images; with slash!
$img_path = $data_path."images/";

##### path with all thumbnails; with slash!
$thumb_path = $data_path."thumbnails/";

##### the path, where the original images were saved; with slash!
##### path has to begin from the root of the gallery!
$tmp_path = "./tmp/";

##### this calculates all shown pictures on one page
$images_per_page = $rows*$images_per_row;

##### GET variable used for this gallery
$getvar = "fsg";

##### PHPSESSID variable; please choose a new name!
$sessvar = "sid";

##### include the correct language-pack
include("./lang/".$abbr_lang);

##### set the correct template paths
$template_path = "./templates/".$template;
$template_images_path = $template_path."images/";

##### get all categories
$cats = list_all_cats($gallery_path);

##### this will help the program to run, if register_globals = off...
// GET
if (!empty($_GET)) {
    extract_vars($_GET, $GLOBALS);
} elseif (!empty($HTTP_GET_VARS)) {
    extract_vars($HTTP_GET_VARS, $GLOBALS);
}

// output built version and system information
if (isset($_GET['built'])) {
 	echo "<br><b>Copyright (c) 2004 Fabian Schneider - www.fabian-schneider.com - webmaster@fabian-schneider.com - deuslatinum@web.de<br><br>";
	echo "<h1>FS Galerie ".$version."</h1><br>";
	echo "Version: ".$version."<br><br>";
	echo "Built: ".$_built."<br><br><br>";
	echo "Info[com]: ". get_fileinfo("./common.inc.php") ."<br><br>";
	echo "Info[con]: ". get_fileinfo("./config.ini") ."<br><br>";
	echo "Info[fun]: ". get_fileinfo("./functions.inc.php") ."<br><br>";
	echo "Info[ind]: ". get_fileinfo("./index.php") ."<br><br>";
	if (isset($_GET['hfile'])) {
		echo "<font color=\"#FF0000\"><br>Hash: ".$_GET['hfile'].": ". get_md5($_GET['hfile']) ."</font><br><br>";
	}
	exit();
}

// SERVER
if (!empty($_SERVER)) {
    if (isset($_SERVER['PHP_SELF'])) {
        $PHP_SELF = $_SERVER['PHP_SELF'];
    }
    if (isset($_SERVER['REMOTE_ADDR'])) {
        $REMOTE_ADDR = $_SERVER['REMOTE_ADDR'];
    }
    if (isset($_SERVER['SERVER_NAME'])) {
        $SERVER_NAME = $_SERVER['SERVER_NAME'];
    }
    if (isset($_SERVER['REQUEST_URI'])) {
        $REQUEST_URI = $_SERVER['REQUEST_URI'];
    }
    if (isset($_SERVER['HTTP_USER_AGENT'])) {
    	$HTTP_USER_AGENT = $_SERVER['HTTP_USER_AGENT'];
    }
} elseif (!empty($HTTP_SERVER_VARS)) {
    if (isset($HTTP_SERVER_VARS['PHP_SELF'])) {
        $PHP_SELF = $HTTP_SERVER_VARS['PHP_SELF'];
    }
    if (isset($HTTP_SERVER_VARS['REMOTE_ADDR'])) {
        $REMOTE_ADDR = $HTTP_SERVER_VARS['REMOTE_ADDR'];
    }
    if (isset($HTTP_SERVER_VARS['SERVER_NAME'])) {
        $SERVER_NAME = $HTTP_SERVER_VARS['SERVER_NAME'];
    }
    if (isset($HTTP_SERVER_VARS['REQUEST_URI'])) {
        $REQUEST_URI = $HTTP_SERVER_VARS['REQUEST_URI'];
    }
    if (isset($HTTP_SERVER_VARS['HTTP_USER_AGENT'])) {
    	$HTTP_USER_AGENT = $HTTP_SERVER_VARS['HTTP_USER_AGENT'];
    }
}
// there is a security problem with $goto, so I will not accept $goto...
if (isset($goto)) {
    unset($goto);
}

##### decode the GET variable and delete all other foreign GET variables
$get = base64_decode($_GET[$getvar]);

// look for plugins and do not delete them
$_plugin = "";
if (isset($_GET['plugin'])) {
	$_plugin = $_GET['plugin'];
}

// delete all $_GET
while(list($key,$value) = each($_GET)) {
	unset($$key);
}
unset($_GET);
$_GET = array();

// extract the gallery's GET
$get_arr = explode("&",$get);
$i = 0;
while($i < count($get_arr)) {
	if (!empty($get_arr[$i])) {
		$get_temp = explode("=",$get_arr[$i]);
		$$get_temp[0] = $get_temp[1];
		$_GET[$get_temp[0]] = $get_temp[1];
	}
	$i++;
}
// "backup" the plugins
if (!empty($_plugin)) {
	$plugin = $_plugin;
	$_GET['plugin'] = $_plugin;
}

##### decode and remove all html + php tags from $category and $gallery variable
##### for security reason from $img_id, $action, $page, $plugin and $file, too
$category 	= strip_tags(rawurldecode($category));
$gallery 	= strip_tags(rawurldecode($gallery));
$img_id 	= strip_tags(rawurldecode($img_id));
$action 	= strip_tags(rawurldecode($action));
$page 		= strip_tags(rawurldecode($page));
$file 		= strip_tags(rawurldecode($file));
$plugin 	= strip_tags(rawurldecode($plugin));

?>
