<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: The main file of the program,that organises everything*|
 \*                                                                         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 27.04.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: index.php                                    |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/



##### the header- information will be prepared in order to achieve
##### a maximum of security for all pictures (except the thumbnails)
################################################################################

// include the configuration, the functions and the copyright
include_once("./common.inc.php");

session_name($sessvar);
session_start();
check_cookie("set");

// do a logout, if requested
if ($_GET['action'] == "logout") {
	logout();
}

// set $logged_in (needed for login() etc.)
$logged_in = (isset($_SESSION['session_logged_in']))? $_SESSION['session_logged_in'] : false;

// this will disable the browser's cache
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") ." GMT");
header("Pragma: no-cache");
header("Cache-Control: no-store, no-cache, max-age=0, must-revalidate");

// Challenge-ID
mt_srand((double)microtime()*1000000);

$random = mt_rand();
$random = md5(uniqid($random,TRUE));

if(!isset($_SESSION['sess_challenge_id'])) {
    $_SESSION['sess_challenge_id'] = $random;
}

##### now, I can start the "real" program...
################################################################################

// kill bad requests
if (($action == "catoverview") && (!isset($category) || empty($category))) {
	unset($action);
}

if (($action == "preview") && (!isset($category) || empty($category) || !isset($gallery) || empty($gallery))) {
	unset($action);
}

if (($action == "show") && (!isset($category) || empty($category) || !isset($gallery) || empty($gallery) || !isset($img_id) || empty($img_id))) {
	unset($action);
}

if (($action == "print") && (!isset($file) || empty($file) || !isset($category) || empty($category) || !isset($gallery) || empty($gallery) || !isset($img_id) || empty($img_id))) {
	unset($action);
}

if (($action == "mail") && (!isset($file) || empty($file) || !$ecards || !isset($category) || empty($category) || !isset($gallery) || empty($gallery) || !isset($img_id) || empty($img_id))) {
	unset($action);
}

// decide what we will do, if no $action is given
// we will not do a printing or mailing job!
if (!isset($action) || empty($action)) {
	if (isset($category) && !empty($category) && isset($gallery) && !empty($gallery)) {
		if (isset($img_id) && !empty($img_id)) {
			$action = "show";
		} else {
			$action = "preview";
		}
	} elseif (isset($category) && !empty($category)) {
		$action = "catoverview";
	}
}

// check, if there are any plugins requested
if (!empty($plugin)) {
	if (file_exists($plugin_path.$plugin.".inc.php")) {
		include_once($plugin_path.$plugin.".inc.php");
		if ($stop) {
			exit();
		}
	}
}

// show the requested information
switch($action) {
	
	// preview of a gallery
	case "preview":
	    $path = $gallery_path.$category."/";
	    if (!is_dir($path)) {
			send_error(1);
		}
	    $galleries = list_all_dbs($path);
	    $i = 0;
	    $max_galleries = count($galleries);
	    while ($i < $max_galleries) {
	    	// search for the correct gallery
	    	if ($gallery == get_gallery_name($galleries[$i])) {
	    		// correct gallery has been found, so display the thumbnails
	    		$fp = @file($galleries[$i]);
	    		$images = "";

				// calculate the amount of pages and send the images
				// check the given page
				if ($page < 0 || !isset($page) || empty($page)) $page = 1;

				// generate the page numbers
    			$page = $page;
    			$all_pictures = count($fp);
    			$number_of_pages = ceil($all_pictures/$images_per_page);
    			if ($number_of_pages == 0) {
        			$number_of_pages = 1;
    			}
    			if ($page > $number_of_pages) {
        			$page = $number_of_pages;
    			}
    			$from_entry = (($page-1)*$images_per_page);
    			$back = $page-1;
    			$forward = $page+1;
    			$end_of_for = $page+($max_pages-1)/2;
    			$start_of_for = $page-($max_pages-1)/2;
    			if ($start_of_for > $number_of_pages-$max_pages+1) {
        			$start_of_for = $number_of_pages-$max_pages+1;
    			}
    			if ($start_of_for < 1) {
        			$start_of_for = 1;
    			}
    			if ($end_of_for < $max_pages && $number_of_pages < $max_pages) {
        			$end_of_for = $number_of_pages;
    			} elseif ($end_of_for < $max_pages && $number_of_pages > $max_pages) {
        			$end_of_for = $max_pages;
    			} elseif ($end_of_for >= $number_of_pages) {
        			$end_of_for = $number_of_pages;
    			}
    			$pages = "<span style=\"font-size: 9pt\">".$lang['pages']." <a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&page=1"). "\" class=\"kc\"><<</a>|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&page=".$back) ."\" class=\"kc\"><</a>";
    			if ($page > ($max_pages-1)/2+1 && $number_of_pages > $max_pages) {
        			if ($page > $number_of_pages-(($max_pages-1)/2)) {
            			$forward_max = $number_of_pages-$max_pages;
        			} else {
            			$forward_max = $page-(($max_pages-1)/2+1);
        			}
        			$pages .= "|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&page=".$forward_max) ."\">...</a>";
    			}
    			for ($i=$start_of_for;$i<=$end_of_for;$i++) {
        			if ($page == $i) {
                		$pages .= "|<b>".$i."</b>";
        			} else {
                		$pages .= "|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&page=".$i) ."\" class=\"kc\">".$i."</a>";
        			}
    			}
    			if ($page < $number_of_pages-(($max_pages-1)/2) && $number_of_pages > $max_pages) {
        			if ($page < ($max_pages-1)/2+1) {
            			$max_forward = $max_pages+1;
        			} else {
            			$max_forward = $page+(($max_pages-1)/2+1);
        			}
        			$pages .= "|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&page=".$max_forward) ."\" class=\"kc\">...</a>";
    			}
    			$pages .= "|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&page=".$forward) ."\" class=\"kc\">></a>|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&page=".$number_of_pages) ."\" class=\"kc\">>></a></span>&nbsp;&nbsp;&nbsp;";

				##### send all images of the gallery; put in some space in unused positions of the table
				// from which element of the array have the pictures to be shown
				$up = $images_per_page*($page-1);
				// to which element of the array have the pictures to be shown
				$to = $up+$images_per_page;

				// add the page numbers
				$images .= "<tr>
                				<td colspan=\"".$images_per_row."\" align=\"right\">".$pages."</td>
            				</tr>
            				<tr>\n";

				// send the pictures
				while ($to > $up) {
        			// check whether the requested page is higher than the existing pages
        			if ($page > $number_of_pages) {
            			@header("Location: ". get_link("action=".$action."&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&page=".$number_of_pages) );
        			}

        			// get information from the database
        			$data = explode("|",$fp[$up]);
        			$id = abs($data[0]);
        			$current_id = $id-1;
        			$gallery = $data[2];

        			// did we reach the next row of the table??
        			if ( $current_id % $images_per_row == 0 && $current_id > 0 ) {
            			$images .= "</tr><tr>\n";
        			}

        			// put in the thumbnails
        			$width = round(100/$images_per_row); // 100 = 100% of the table
        			$images .= "<td width=\"".$width."%\" align=\"center\"><a href=\"". get_link("action=show&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&img_id=".$data[0]."&page=".$page) ."\"><img src=\"".$thumb_path.$data[1]."\" border=\"0\" alt=\"".$data[3]."\"></a></td>\n";

        			// did we reach the end; do we have to add some space??
        			if (($up == $all_pictures-1) && ($id % $images_per_row != 0)) {
            			if ($id > $images_per_row) {
                			$rest = $id % $images_per_row;
            			} else {
                			$rest = $images_per_row % $id;
            			}
            			for ($j=1;$j<=$rest;$j++) {
                			$images .= "<td width=\"".$width."%\">&nbsp;</td>\n";
            			}
            			break;
        			} elseif ($up == $all_pictures-1) {
            			break;
        			}
        			$up++;
				}

				// add the page numbers
				$images .= "</tr>
            				<tr>
                				<td colspan=\"".$images_per_row."\" align=\"right\">".$pages."</td>
            				</tr>\n";
				break;
	    	}
	    	$i++;
	    }
	    if (empty($fp) || !isset($fp)) {
	    	send_error(2);
	    }
		// start the output
		$out_array = array(
				            "%col%" => $images_per_row,
				            "%gallery_text%" => $lang['gallery'],
				            "%up%" => get_link("action=catoverview&category=".$category),
				            "%upwards%" => $template_images_path."up.gif",
				            "%up_text%" => $lang['up_to_catpreview'],
				            "%gallery%" => $gallery,
				            "%pictures%" => $images
							);
		parse_template("preview.html",$out_array,0);
	    break;
	    
	// show a single image
	case "show":
	    // let us get the needed information to display the image correctly
		$data = get_image_information($category,$gallery,$img_id);
		$max_images = $data[7];
		
		// all information were collected; now getting ready for parsing
		// first: titel, description and the copyright information of the image
		$id = abs($data[0]);
		$title = $data[3];
		$description = "";
		if (substr($data[4],0,3) != "xxx") {
            $description = $data[4];
        }
        $copyright = $lang['copyright']." ".$data[5]." (".$data[6].")";
        // second: navigation
        $nav = "";
		if ($id-1 > 0) {
    		$nav .= "<a href=\"". get_link("action=show&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&img_id=". get_number($id-1) ."&page=".$page) ."\"><img src=\"".$template_images_path."back.gif\" border=\"0\" alt=\"".$lang['last_image']."\"></a>";
		}
		$nav .= "&nbsp;<a href=\"". get_link("action=preview&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&page=".$page) ."\"><img src=\"".$template_images_path."up.gif\" border=\"0\" alt=\"".$lang['up_to_galpreview']."\"></a>&nbsp;";
		if ($id < $max_images) {
    		$nav .= "<a href=\"". get_link("action=show&category=". rawurlencode($category) ."&gallery=". rawurlencode($gallery) ."&img_id=". get_number($id+1) ."&page=".$page) ."\"><img src=\"".$template_images_path."next.gif\" border=\"0\" alt=\"".$lang['next_image']."\"></a>";
		}
		if (($id >= $max_images) && ($id-1 <= 0)) {
    		$nav .= "&nbsp;";
		}
		// third: the protected image
		$img = getimagesize($img_path.$data[1]);
		$width = $img[0];
		$height = $img[1];
		if ($security_system) {
			$image = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"".$width."\" height=\"".$height."\" align=\"center\">\n
                		<tr>\n
                    		<td width=\"".$width."\" height=\"".$height."\" background=\"read_image.php?img=". rawurlencode($img_path.$data[1]) ."&challenge=".$_SESSION['sess_challenge_id']."&path=". rawurlencode($data_path) ."\">\n
                        		<img border=\"0\" src=\"".$data_path."blind.gif\" width=\"".$width."\" height=\"".$height."\" alt=\"".$bild."\">\n
                    		</td>\n
                		</tr>\n
             		</table>\n";
        } else {
        	$image = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"".$width."\" height=\"".$height."\" align=\"center\">\n
                		<tr>\n
                    		<td width=\"".$width."\" height=\"".$height."\">\n
                        		<img border=\"0\" src=\"".$img_path.$data[1]."\" width=\"".$width."\" height=\"".$height."\" alt=\"".$bild."\">\n
                    		</td>\n
                		</tr>\n
             		</table>\n";
        }
		// last: the print & mail url
		$print_url = get_link("action=print&file=". rawurlencode($data[1]) ."&category=".$category."&gallery=".$gallery."&img_id=".$img_id);
		$mail_url = get_link("action=mail&file=". rawurlencode($data[1]) ."&category=".$category."&gallery=".$gallery."&img_id=".$img_id);
		
	    // we will print the mail button, if ecards are allowed
		if ($ecards) {
			$mail = "<a href=\"".$mail_url."\"><img src=\"".$template_images_path."mail.gif\" border=\"0\" alt=\"".$lang['mail']."\"></a>";
		} else {
			$mail = "";
		}
		// start the output
		$out_array = array(
		                    "%print_url%" => $print_url,
		                    "%print_image%" => $template_images_path."print.gif",
		                    "%print%" => $lang['print'],
		                    "%mail%" => $mail,
		                    "%gallery_text%" => $lang['gallery'],
				            "%gallery%" => $gallery,
				            "%title%" => $title,
				            "%up%" => get_link("action=catoverview&category=".$category),
				            "%upwards%" => $template_images_path."up.gif",
				            "%up_text%" => $lang['up_to_catpreview'],
				            "%nav%" => $nav,
				            "%image%" => $image,
				            "%description%" => $description,
				            "%copyright%" => $copyright
							);
		parse_template("show.html",$out_array,0);
	    break;
	    
	// show all available galleries of a category
	case "catoverview":
        $galleries = list_all_dbs($gallery_path."/".$category."/");
        $max_galleries = count($galleries);
        
		// calculate the amount of pages
		// check the given page
		if ($page < 0 || !isset($page) || empty($page)) $page = 1;

		// generate the page numbers
    	$page = $page;
    	$number_of_pages = ceil($max_galleries/$galleries_per_page);
    	if ($number_of_pages == 0) {
        	$number_of_pages = 1;
    	}
    	if ($page > $number_of_pages) {
        	$page = $number_of_pages;
    	}
    	$from_entry = (($page-1)*$galleries_per_page);
    	$back = $page-1;
    	$forward = $page+1;
    	$end_of_for = $page+($max_pages-1)/2;
    	$start_of_for = $page-($max_pages-1)/2;
    	if ($start_of_for > $number_of_pages-$max_pages+1) {
        	$start_of_for = $number_of_pages-$max_pages+1;
    	}
    	if ($start_of_for < 1) {
        	$start_of_for = 1;
    	}
    	if ($end_of_for < $max_pages && $number_of_pages < $max_pages) {
        	$end_of_for = $number_of_pages;
    	} elseif ($end_of_for < $max_pages && $number_of_pages > $max_pages) {
        	$end_of_for = $max_pages;
    	} elseif ($end_of_for >= $number_of_pages) {
        	$end_of_for = $number_of_pages;
    	}
    	$pages = "<span style=\"font-size: 9pt\">".$lang['pages']." <a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&page=1") ."\" class=\"kc\"><<</a>|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&page=".$back) ."\" class=\"kc\"><</a>";
    	if ($page > ($max_pages-1)/2+1 && $number_of_pages > $max_pages) {
        	if ($page > $number_of_pages-(($max_pages-1)/2)) {
            	$forward_max = $number_of_pages-$max_pages;
        	} else {
            	$forward_max = $page-(($max_pages-1)/2+1);
        	}
        	$pages .= "|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&page=".$forward_max) ."\">...</a>";
    	}
    	for ($i=$start_of_for;$i<=$end_of_for;$i++) {
        	if ($page == $i) {
                $pages .= "|<b>".$i."</b>";
        	} else {
                $pages .= "|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&page=".$i) ."\" class=\"kc\">".$i."</a>";
        	}
    	}
    	if ($page < $number_of_pages-(($max_pages-1)/2) && $number_of_pages > $max_pages) {
        	if ($page < ($max_pages-1)/2+1) {
            	$max_forward = $max_pages+1;
        	} else {
            	$max_forward = $page+(($max_pages-1)/2+1);
        	}
        	$pages .= "|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&page=".$max_forward) ."\" class=\"kc\">...</a>";
    	}
    	$pages .= "|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&page=".$forward) ."\" class=\"kc\">></a>|<a href=\"". get_link("action=".$action."&category=". rawurlencode($category) ."&page=".$number_of_pages) ."\" class=\"kc\">>></a></span>&nbsp;&nbsp;&nbsp;";
    	// from which element of the array have the galleries to be shown
		$up = $galleries_per_page*($page-1);
		// to which element of the array have the pictures to be shown
		$to = $up+$galleries_per_page;
        $output .= "
					<tr>
						<td width=\"100%\">
						<table width=\"100%\" align=\"center\" cellspacing=\"0\" cellpadding=\"3\" border=\"0\">
                    	<tr>
                        	<td align=\"left\" class=\"highlight\"><img src=\"".$template_images_path."cat.gif\" border=\"0\" alt=\"".$category."\">&nbsp;&nbsp;<b>".$category."</b></td>
                        	<td align=\"right\" class=\"highlight\">".$pages."</td>
                        	<td align=\"right\" class=\"highlight\"><a href=\"". get_link("") ."\"><img src=\"".$template_images_path."up.gif\" border=\"0\" alt=\"".$lang['up_to_catoverview']."\"></a></td>
						</tr>
						</table>
						</td>
					</tr>
					<tr>
						<td width=\"100%\">
						<table width=\"100%\" align=\"center\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n";
						
        while ($to > $up) {
        	// check whether the requested page is higher than the existing pages
        	if ($page > $number_of_pages) {
            	@header("Location: ". get_link("action=".$action."&category=". rawurlencode($category) ."&page=".$number_of_pages) );
        	}
        	// output for the galleries
        	$gallery_name = get_gallery_name($galleries[$up]);
        	$output .= "
						<tr>
							<td width=\"10%\" class=\"normal\">&nbsp;</td>
							<td width=\"30%\" align=\"left\" valign=\"middle\" class=\"normal\"><a href=\"". get_link("action=preview&category=".$category."&gallery=".$gallery_name) ."\"><img src=\"".$template_images_path."dot.gif\" border=\"0\">&nbsp;<b>".$gallery_name."</b></a></td>
							<td width=\"60%\" align=\"left\" valign=\"middle\" class=\"normal\"><a href=\"". get_link("action=preview&category=".$category."&gallery=".$gallery_name) ."\">". get_random_images($galleries[$up],$max_random_images) ."</a></td>
						</tr>\n";
        	// did we reach the end??
        	if ($up == $max_galleries-1) {
            	break;
        	}
        	$up++;
        }
        $output .= "
						</table>
						</td>
					</tr>\n";
    	// start the output
    	$out_array = array(
							"%galleries%" => $output,
							"%all_galleries%" => $lang['all_galleries']
							);
    	parse_template("catoverview.html",$out_array,0);
		break;
		
	// print a selected image
	case "print":
	    // get the information about the image
		$data = get_image_information($category,$gallery,$img_id);
		// first: the image
		$img = getimagesize($img_path.$file);
		$width = $img[0];
		$height = $img[1];
		if ($security_system) {
			$image = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"".$width."\" height=\"".$height."\" align=\"center\">\n
                		<tr>\n
                    		<td width=\"".$width."\" height=\"".$height."\" background=\"read_print_image.php?img=". rawurlencode($img_path.$file) ."&challenge=".$_SESSION['sess_challenge_id']."&path=". rawurlencode($data_path) ."&category=".$category."&gallery=".$gallery."&img_id=".$img_id."\">\n
                        		<a href=\"javascript:window.close();\"><img alt=\"".$lang['close']."\" border=\"0\" src=\"".$data_path."blind.gif\" width=\"".$width."\" height=\"".$height."\"></a>\n
                    		</td>\n
                		</tr>\n
             		</table>\n";
        } else {
        	$image = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"".$width."\" height=\"".$height."\" align=\"center\">\n
                		<tr>\n
                    		<td width=\"".$width."\" height=\"".$height."\">\n
                        		<a href=\"javascript:window.close();\"><img alt=\"".$lang['close']."\" border=\"0\" src=\"".$img_path.$file."\" width=\"".$width."\" height=\"".$height."\"></a>\n
                    		</td>\n
                		</tr>\n
             		</table>\n";
        }
		// second: copyright notice
		$copyright = "<b>".$lang['copyright']." ".$data[5]."</b>";
		// third: information about the owner
		$information_table = "
								<table width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"0\" align=\"center\">
								<tr>
									<td align=\"right\"><b>".$lang['photographer'].":</b></td>
									<td align=\"left\">".$data[5]."</td>
								</tr>
								<tr>
									<td align=\"right\"><b>".$lang['email'].":</b></td>
									<td align=\"left\">".$data[6]."</td>
								</tr>
								<tr>
									<td align=\"right\"><b>".$lang['homepage'].":</b></td>
									<td align=\"left\">".$homepage_url."</td>
								</tr>
								</table>\n";
    	// start the output
    	$out_array = array(
    	                    "%print%" => $lang['print'],
    	                    "%print_image%" => $template_images_path."print.gif",
							"%copyright%" => $copyright,
							"%image%" => $image,
							"%information%" => $information_table
							);
    	parse_template("print.html",$out_array,0);
	    break;

	// mail an ecard to someone
	case "mail":
		// POST filtern
		$yourname = $_POST['yourname'];
		$youremail = $_POST['youremail'];
		$rename = $_POST['rename'];
		$reemail = $_POST['reemail'];
		$text = $_POST['text'];
		$send = $_POST['send'];
		
	    if ($send) {
	    	if (empty($yourname) || empty($youremail) || empty($rename) || empty($reemail) || empty($text) || !check_email($youremail) || !check_email($reemail)) {
	    		$send = false;
				$msg = $lang['wrong_input'];
			} else {
				##### sending the ecard
				// creating the image
				$img = getimagesize($img_path.$file);
				$width = $img[0];
				$height = $img[1];
				$url = "http://".$SERVER_NAME. dirname($REQUEST_URI);
				if ($security_system) {
					$image = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"".$width."\" height=\"".$height."\" align=\"center\">\n
                				<tr>\n
                    				<td width=\"".$width."\" height=\"".$height."\" background=\"".$url."/read_mail_image.php?img=". rawurlencode($img_path.$file) ."&path=". rawurlencode($data_path) ."&category=".$category."&gallery=".$gallery."&img_id=".$img_id."\">\n
                        				<img border=\"0\" src=\"".$url."/".$data_path."blind.gif\" width=\"".$width."\" height=\"".$height."\">\n
                    				</td>\n
                				</tr>\n
             				</table>\n";
             	} else {
             		$image = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"".$width."\" height=\"".$height."\" align=\"center\">\n
                				<tr>\n
                    				<td width=\"".$width."\" height=\"".$height."\">\n
                        				<img border=\"0\" src=\"".$url."/".$img_path.$file."\" width=\"".$width."\" height=\"".$height."\">\n
                    				</td>\n
                				</tr>\n
             				</table>\n";
             	}
				// creating the subject
				$subject = $yourname." ".$lang['subject'];
				// the message
				$text = str_replace("\n","<br>",$text);
				$out_array = array(
				            "%subject%" => $subject,
				            "%image%" => $image,
				            "%text%" => $text
							);
				$message = parse_template("./templates/mail.html",$out_array,1);
				// preparing the header
				$header = "From: ".$yourname."<".$youremail.">\n";
				$header .= "Reply-To: ".$youremail."\n";
				$header .= "Content-Type: text/html";
				// mailing the ecard
				$sending = @mail($reemail,$subject,$message,$header);
				$send = false;
				if ($sending) {
					$msg = $lang['mail_sent'];
				} else {
					$msg = $lang['mail_not_sent'];
				}
			}
	    }
		if (!$send) {
			$file = rawurldecode($file);
			$text = str_replace("<br>","\n",$text);
			// the form with the image
			$form = "
		        <tr>
		            <th colspan=\"2\">".$lang['sending_an_ecard']."</th>
				</tr>
				<tr>
				    <td colspan=\"2\" align=\"center\"><b>".$msg."</b></td>
				</tr>
				<tr>
				    <td colspan=\"2\" align=\"center\">
				        <img border=\"0\" src=\"".$thumb_path.$file."\" alt=\"".$lang['big']."\">
					</td>
				</tr>
				<tr>
				    <td colspan=\"2\">
										<form action=\"". get_link("action=mail&file=". rawurlencode($file) ."&category=".$category."&gallery=".$gallery."&img_id=".$img_id) ."\" method=\"post\">
										<input type=\"hidden\" name=\"send\" value=\"true\">
					</td>
				</tr>
				<tr>
				    <td align=\"right\"><b>".$lang['your_name'].":</b></td>
				    <td align=\"left\"><input type=\"text\" name=\"yourname\" size=\"40\" value=\"".$yourname."\"></td>
				</tr>
				<tr>
				    <td align=\"right\"><b>".$lang['your_email'].":</b></td>
				    <td align=\"left\"><input type=\"text\" name=\"youremail\" size=\"40\" value=\"".$youremail."\"></td>
				</tr>
				<tr>
				    <td align=\"right\"><b>".$lang['re_name'].":</b></td>
				    <td align=\"left\"><input type=\"text\" name=\"rename\" size=\"40\" value=\"".$rename."\"></td>
				</tr>
				<tr>
				    <td align=\"right\"><b>".$lang['re_email'].":</b></td>
				    <td align=\"left\"><input type=\"text\" name=\"reemail\" size=\"40\" value=\"".$reemail."\"></td>
				</tr>
				<tr>
				    <td align=\"right\"><b>".$lang['text'].":</b></td>
				    <td align=\"left\">HTML ".$lang['is_allowed']."</td>
				</tr>
				<tr>
				    <td colspan=\"2\" align=\"center\"><textarea name=\"text\" cols=\"45\" rows=\"7\">".$text."</textarea></td>
				</tr>
				<tr>
				    <td colspan=\"2\" align=\"center\"><input type=\"submit\" name=\"submit\" value=\"".$lang['submit']."\">&nbsp;<input type=\"reset\" name=\"reset\" value=\"".$lang['reset']."\"></form></td>
				</tr>
		        \n";
			// start the output
			$out_array = array(
				            "%col%" => 2,
				            "%gallery_text%" => $lang['gallery'],
				            "%up%" => get_link("action=show&category=".$category."&gallery=".$gallery."&img_id=".$img_id),
				            "%upwards%" => $template_images_path."up.gif",
				            "%up_text%" => $lang['up_to_image'],
				            "%gallery%" => $gallery,
				            "%pictures%" => $form
							);
			parse_template("preview.html",$out_array,0);
	    }
	    break;
	    
	// show all available categories
    default:
        $output = "<table width=\"100%\" align=\"center\" cellspacing=\"0\" cellpadding=\"3\" border=\"0\">\n";
        $all_galleries = 0;$all_number_of_images = 0;
        $i = 0;
        $max_cats = count($cats);
        while ($i < $max_cats) {
        	$class = "highlight";
        	if ($i % 2 != 0) {
        		$class = "normal";
        	}
        	$category_name = get_category_name($cats[$i]);
        	$galleries = list_all_dbs($cats[$i]);
        	$number_of_images = count_images($galleries);
        	$max_galleries = count($galleries);
        	$all_galleries = $all_galleries + $max_galleries;
        	$all_number_of_images = $all_number_of_images + $number_of_images;
        	if ($max_cats == 1 && $max_galleries == 1) {
        		@header("Location: ". get_link("action=preview&category=".$category_name."&gallery=". get_gallery_name($galleries[0])) );
        		exit();
        	}
        	$output .= "
						<tr>
							<td align=\"left\" class=\"".$class."\"><a href=\"". get_link("action=catoverview&category=".$category_name) ."\"><b>&nbsp;&nbsp;<img src=\"".$template_images_path."cat.gif\" border=\"0\" alt=\"".$lang['cat']."\">&nbsp;&nbsp;".$category_name."</b></a></td>
							<td align=\"right\" class=\"".$class."\"><img src=\"".$template_images_path."stat.gif\" border=\"0\" alt=\"".$lang['stat']."\">&nbsp;<b>".$lang['galleries'].": ".$max_galleries."&nbsp;&nbsp;".$lang['images'].": ".$number_of_images."</b></td>
						</tr>\n";
        	$i++;
        }
        $output .= "
						<tr>
							<td align=\"center\" colspan=\"2\" class=\"normal2\"><img src=\"".$template_images_path."stat.gif\" border=\"0\" alt=\"".$lang['stat']."\">&nbsp;<b>".$lang['all_stats'].": ".$lang['galleries'].": ".$all_galleries."&nbsp;&nbsp;".$lang['images'].": ".$all_number_of_images."</b></td>
						</tr>\n";
        $output .= "</table>\n";
        // start the output
        $out_array = array(
							"%categories%" => $output,
							"%all_categories%" => $lang['all_categories']
							);
        parse_template("overview.html",$out_array,0);
        break;
}

?>
