<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This plugin will configure your gallery               *|
 \*                                                                         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 21.10.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: config.inc.php                               |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/

##### Code of the setup plugin
################################################################################
define("FS_GALERIE_PLUGIN_CONFIG",$version);

$setup = "<!-- Plugin: Config Wizard for FS Galerie 2.x -->\n\n";
// first of all, let us collect all information send via POST
// this will not be done by the main file: common.inc.php, so we have to do it
if (!empty($_POST)) {
    extract_vars($_POST, $GLOBALS);
} else if (!empty($HTTP_POST_VARS)) {
    extract_vars($HTTP_POST_VARS, $GLOBALS);
}

// how many steps will this wizard have?
$steps = 1;

// just for control...
$exit = false;

// before we can start the steps, check whether we are logged in or not
// if so, a "session id" will get created automatically, if you use get_link(string get,[string file]) for all of your links!
login();

// now, start the steps, if logged in:
if (!$exit && $logged_in) {
	if (!isset($step) || empty($step)) {
		$step = 1;
	}
	// decide which step!
	switch($step) {
		case "1":
		    ##### decide which preferences should be shown:
		    $c_homepage 	= (string) 	(isset($_POST['c_homepage']))	? $_POST['c_homepage'] 			: $homepage_url;
		    $c_usr		 	= (string) 	(isset($_POST['c_usr']))		? $_POST['c_usr'] 				: $login_usr;
		    $c_pwd 			= (string) 	(isset($_POST['c_pwd']))		? $_POST['c_pwd'] 				: "";
		    $c_pwd_re 		= (string) 	(isset($_POST['c_pwd_re']))		? $_POST['c_pwd_re'] 			: "";
		    $c_lang 		= (string) 	(isset($_POST['c_lang']))		? $_POST['c_lang'] 				: $abbr_lang;
		    $c_temp 		= (string) 	(isset($_POST['c_temp']))		? $_POST['c_temp'] 				: $template;
		    $c_ecards 		= (bool) 	(isset($_POST['c_ecards']))		? $_POST['c_ecards'] 			: $ecards;
		    $c_security 	= (bool) 	(isset($_POST['c_security']))	? $_POST['c_security'] 			: $security_system;
		    $c_rows 		= (int) 	(isset($_POST['c_rows']))		? intval($_POST['c_rows']) 		: $rows;
		    $c_per_row 		= (int) 	(isset($_POST['c_per_row']))	? intval($_POST['c_per_row']) 	: $images_per_row;
		    $c_random_img 	= (int) 	(isset($_POST['c_random_img']))	? intval($_POST['c_random_img']) : $max_random_images;
		    $c_gal 			= (int) 	(isset($_POST['c_gal']))		? intval($_POST['c_gal']) 		: $galleries_per_page;
		    $c_pages 		= (int) 	(isset($_POST['c_pages']))		? intval($_POST['c_pages']) 	: $max_pages;
		    $c_algorithm 	= (int) 	(isset($_POST['c_algorithm']))	? intval($_POST['c_algorithm']) : $algorithm;
		    $c_timeout 		= (int) 	(isset($_POST['c_timeout']))	? intval($_POST['c_timeout']) 	: $timelimit;
		    $c_size 		= (int) 	(isset($_POST['c_size']))		? intval($_POST['c_size']) 		: $img_max_size;
		    $c_upload_imgs 	= (int) 	(isset($_POST['c_upload_imgs']))? intval($_POST['c_upload_imgs']) : $max_upload;
		    $c_img_size 	= (int) 	(isset($_POST['c_img_size']))	? intval($_POST['c_img_size']) 	: $max_imagesize;
		    $c_zip_size 	= (int) 	(isset($_POST['c_zip_size']))	? intval($_POST['c_zip_size']) 	: $max_zipsize;

			##### check the send data and save it
			if ($_POST['send_but'] == 1) {
				// reload language, so that everything is ok
				include("./lang/".$c_lang);
				$msg = "<ul>";$error = false;
				##### start checking the data...
				if (empty($c_homepage)) {
					$error = true;
					$msg .= "<li>".$lang['config.e.homepage']."</li>";
				} elseif (!ereg("http://",$c_homepage)) {
					$c_homepage = "http://".$c_homepage;
				}
				if (empty($c_usr)) {
					$error = true;
					$msg .= "<li>".$lang['config.e.usr']."</li>";
				}
				if ($c_pwd != $c_pwd_re) {
					$error = true;
					$msg .= "<li>".$lang['config.e.pwd']."</li>";
				}
				if (empty($c_rows) || !is_int($c_rows) || $c_rows <= 0) {
					$error = true;
					$msg .= "<li>".$lang['config.e.rows']."</li>";
				}
				if (empty($c_per_row) || !is_int($c_per_row) || $c_per_row <= 0) {
					$error = true;
					$msg .= "<li>".$lang['config.e.per_row']."</li>";
				}
				if (empty($c_random_img) || !is_int($c_random_img) || $c_random_img <= 0) {
					$error = true;
					$msg .= "<li>".$lang['config.e.random_img']."</li>";
				}
				if (empty($c_gal) || !is_int($c_gal) || $c_gal <= 0) {
					$error = true;
					$msg .= "<li>".$lang['config.e.gal']."</li>";
				}
				if (empty($c_pages) || !is_int($c_pages) || $c_pages % 2 == 0 || $c_pages <= 0) {
					$error = true;
					$msg .= "<li>".$lang['config.e.pages']."</li>";
				}
				if (empty($c_algorithm) || !is_int($c_algorithm) || $c_algorithm < 10) {
					$error = true;
					$msg .= "<li>".$lang['config.e.algorithm']."</li>";
				}
				if (empty($c_timeout) || !is_int($c_timeout) || $c_timeout <= 0) {
					$error = true;
					$msg .= "<li>".$lang['config.e.timeout']."</li>";
				}
				if (empty($c_size) || !is_int($c_size) || $c_size <= 0) {
					$error = true;
					$msg .= "<li>".$lang['config.e.size']."</li>";
				}
				if (empty($c_upload_imgs) || !is_int($c_upload_imgs) || $c_upload_imgs <= 0) {
					$error = true;
					$msg .= "<li>".$lang['config.e.upload_imgs']."</li>";
				}
				if (empty($c_img_size) || !is_int($c_img_size) || $c_img_size <= 0) {
					$error = true;
					$msg .= "<li>".$lang['config.e.img_size']."</li>";
				}
				if (empty($c_zip_size) || !is_int($c_zip_size) || $c_zip_size <= 0) {
					$error = true;
					$msg .= "<li>".$lang['config.e.zip_size']."</li>";
				}
				if ($c_security == "true") {
					$fp = @fopen($img_path.".htaccess","w");
					if (!fwrite($fp,"deny from all")) {
						$msg .= "<li>".$lang['config.e.security']."</li>";
						$error = true;
						$c_security = false;
					}
					$fp = @fclose($fp);
				} elseif ($c_security == "false") {
					$fp = @fopen($img_path.".htaccess","w");
					if (!fwrite($fp,"#")) {
						$msg .= "<li>".$lang['config.e.security']."</li>";
						$error = true;
						$c_security = false;
					}
					$fp = @fclose($fp);
				}
				$msg .= "</ul>";
				
				##### save data, if correct
				if (!$error) {
					$_c_pwd = (empty($c_pwd))? $pw : md5($c_pwd);
					$fp = @fopen("./config.ini","w");
					$text = "<?php\n";
					$text .= "*homepage_url = \"".$c_homepage."\";\n";
					$text .= "*abbr_lang = \"".$c_lang."\";\n";
					$text .= "*template = \"".$c_temp."\";\n";
					$text .= "*max_random_images = ".$c_random_img.";\n";
					$text .= "*rows = ".$c_rows.";\n";
					$text .= "*images_per_row = ".$c_per_row.";\n";
					$text .= "*galleries_per_page = ".$c_gal.";\n";
					$text .= "*max_pages = ".$c_pages.";\n";
					$text .= "*algorithm = ".$c_algorithm.";\n";
					$text .= "*security_system = ".$c_security.";\n";
					$text .= "*ecards = ".$c_ecards.";\n";
					$text .= "*login_usr = \"".$c_usr."\";\n";
					$text .= "*pw = \"".$_c_pwd."\";\n";
					$text .= "*timelimit = ".$c_timeout.";\n";
					$text .= "*img_max_size = ".$c_size.";\n";
					$text .= "*max_upload = ".$c_upload_imgs.";\n";
					$text .= "*max_imagesize = ".$c_img_size.";\n";
					$text .= "*max_zipsize = ".$c_zip_size.";\n";
					$text .= "?>";
					$text = str_replace("*","$",$text);
					if (fwrite($fp,$text)) {
						$msg .= "<li>".$lang['config.success']."</li>";
					} else {
						$msg .= "<li>".$lang['config.no_success']."</li>";
					}
					$fp = @fclose($fp);
				}
			}
			
			$activity = $lang['config.config'];
			
		    ##### get the language packs
		    $all_lang = get_all_lang();
		    $langs = "<select name=\"c_lang\" size=\"1\">";
		    $i = 0;
		    while ($i < count($all_lang)) {
		    	$checked = "";
		    	if ($all_lang[$i] == $c_lang) {
		    		$checked = " selected";
		    	}
		    	$langs .= "<option value=\"".$all_lang[$i]."\"".$checked.">".$all_lang[$i]."</option>";
		    	$i++;
		    }
		    $langs .= "</select>";
		    
		    ##### get the templates
		    $all_temp = get_all_templates();
		    $temp = "<select name=\"c_temp\" size=\"1\">";
		    $i = 0;
		    while ($i < count($all_temp)) {
		    	$checked = "";
		    	if ($all_temp[$i] == $c_temp) {
		    		$checked = " selected";
		    	}
		    	$temp .= "<option value=\"".$all_temp[$i]."\"".$checked.">".$all_temp[$i]."</option>";
		    	$i++;
		    }
		    $temp .= "</select>";
		    
		    ##### decide, if the security system is on or not
		    if ($c_security == "true") {
		    	$security_true = " selected";
		    	$security_false = "";
		    } else {
		    	$security_true = "";
		    	$security_false = " selected";
		    }
		    
		    ##### decide, if ecards are on or not
		    if ($c_ecards == "true") {
		    	$ecards_true = " selected";
		    	$ecards_false = "";
		    } else {
		    	$ecards_true = "";
		    	$ecards_false = " selected";
		    }
		    
		    ##### output
		    $setup .= "<tr><td align=\"center\" colspan=\"2\"><form name=\"config\" action=\"". get_link("plugin=config&step=1") ."\" method=\"post\"><input type=\"hidden\" name=\"send_but\" value=\"1\"><span class=\"error\"><b>".$msg."</b></span></td></tr>\n";
		    $setup .= "
					<tr>
						<td align=\"right\" width=\"65%\"><b>".$lang['config.homepage'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_homepage\" value=\"".$c_homepage."\" size=\"30\"></td>
					</tr>
					<tr class=\"highlight\">
						<td align=\"right\" width=\"65%\"><b>".$lang['config.usr'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_usr\" value=\"".$c_usr."\" size=\"20\"></td>
					</tr>
					<tr>
						<td align=\"right\" width=\"65%\"><b>".$lang['config.pwd'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"password\" name=\"c_pwd\" value=\"".$c_pwd."\" size=\"20\"></td>
					</tr>
					<tr class=\"highlight\">
						<td align=\"right\" width=\"65%\"><b>".$lang['config.pwd_re'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"password\" name=\"c_pwd_re\" value=\"".$c_pwd_re."\" size=\"20\"></td>
					</tr>
					<tr>
						<td align=\"right\" width=\"65%\"><b>".$lang['config.lang']."</b></td>
						<td align=\"left\" width=\"35%\">".$langs."</td>
					</tr>
					<tr class=\"highlight\">
						<td align=\"right\" width=\"65%\"><b>".$lang['config.template'].":</b></td>
						<td align=\"left\" width=\"35%\">".$temp."</td>
					</tr>
					<tr>
						<td align=\"right\" width=\"65%\"><b>".$lang['config.security'].":</b></td>
						<td align=\"left\" width=\"35%\"><select name=\"c_security\" size=\"1\"><option value=\"true\"".$security_true.">".$lang['config.true']."</option><option value=\"false\"".$security_false.">".$lang['config.false']."</option></select></td>
					</tr>
					<tr class=\"highlight\">
						<td align=\"right\" width=\"65%\"><b>".$lang['config.ecards'].":</b></td>
						<td align=\"left\" width=\"35%\"><select name=\"c_ecards\" size=\"1\"><option value=\"true\"".$ecards_true.">".$lang['config.true']."</option><option value=\"false\"".$ecards_false.">".$lang['config.false']."</option></select></td>
					</tr>
					<tr>
						<td align=\"right\" width=\"65%\"><b>".$lang['config.rows'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_rows\" value=\"".$c_rows."\" size=\"5\"></td>
					</tr>
					<tr class=\"highlight\">
						<td align=\"right\" width=\"65%\"><b>".$lang['config.per_row'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_per_row\" value=\"".$c_per_row."\" size=\"5\"></td>
					</tr>
					<tr>
						<td align=\"right\" width=\"65%\"><b>".$lang['config.random_img'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_random_img\" value=\"".$c_random_img."\" size=\"5\"></td>
					</tr>
					<tr class=\"highlight\">
						<td align=\"right\" width=\"65%\"><b>".$lang['config.gal'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_gal\" value=\"".$c_gal."\" size=\"5\"></td>
					</tr>
					<tr>
						<td align=\"right\" width=\"65%\"><b>".$lang['config.pages'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_pages\" value=\"".$c_pages."\" size=\"5\"></td>
					</tr>
					<tr class=\"highlight\">
						<td align=\"right\" width=\"65%\"><b>".$lang['config.algorithm'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_algorithm\" value=\"".$c_algorithm."\" size=\"5\"></td>
					</tr>
					<tr>
						<td align=\"right\" width=\"65%\"><b>".$lang['config.timeout'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_timeout\" value=\"".$c_timeout."\" size=\"5\" onKeyUp=\"document.config.min.value = document.config.c_timeout.value / 60;\"> => <input type=\"text\" name=\"min\" value=\"". $c_timeout/60 ."\" size=\"5\" readonly> ".$lang['config.minutes']."</td>
					</tr>
					<tr class=\"highlight\">
						<td align=\"right\" width=\"65%\"><b>".$lang['config.size'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_size\" value=\"".$c_size."\" size=\"5\"></td>
					</tr>
					<tr>
						<td align=\"right\" width=\"65%\"><b>".$lang['config.upload_imgs'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_upload_imgs\" value=\"".$c_upload_imgs."\" size=\"5\"></td>
					</tr>
					<tr class=\"highlight\">
						<td align=\"right\" width=\"65%\"><b>".$lang['config.img_size'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_img_size\" value=\"".$c_img_size."\" size=\"10\"></td>
					</tr>
					<tr>
						<td align=\"right\" width=\"65%\"><b>".$lang['config.zip_size'].":</b></td>
						<td align=\"left\" width=\"35%\"><input type=\"text\" name=\"c_zip_size\" value=\"".$c_zip_size."\" size=\"10\"></td>
					</tr>
					<tr class=\"highlight\">
						<td align=\"center\" colspan=\"2\"><input type=\"submit\" name=\"submit\" value=\"".$lang['save']."\">&nbsp;<input type=\"reset\" name=\"reset\" value=\"".$lang['reset']."\"></form></td>
					</tr>\n";
		    
		    
			// parse the template
			$out_array = array(
								"%setup%" => $lang['config.config'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
	}
}

##### should the main script be stopped?
################################################################################
$stop = true;

?>
