<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This plugin will optimize and repair your gallery     *|
 \*                                                                         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 01.09.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: repair.inc.php                               |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/

##### Code of the setup plugin
################################################################################
// include some libs; ATTENTION: repair.inc.php will get included by index.php,
// so you have to include the libs with the path "./lib/"!!!
define("FS_GALERIE_PLUGIN_REPAIR",$version);
include("./lib/repair.lib.php");

// this script will never end...
// otherwise it is not possible to create large galleries, because of max_execution_time
@set_time_limit(0);

$setup = "<!-- Plugin: Edit Wizard for FS Galerie 2.x -->\n\n";
// first of all, let us collect all information send via POST
// this will not be done by the main file: common.inc.php, so we have to do it
if (!empty($_POST)) {
    extract_vars($_POST, $GLOBALS);
} else if (!empty($HTTP_POST_VARS)) {
    extract_vars($HTTP_POST_VARS, $GLOBALS);
}

// how many steps will this wizard have?
$steps = 2;

// just for control...
$exit = false;

// before we can start the steps, check whether we are logged in or not
// if so, a "session id" will get created automatically, if you use get_link(string get,[string file]) for all of your links!
login();


// now, start the steps, if logged in:
if (!$exit && $logged_in) {
	if (!isset($step) || empty($step)) {
		$step = 1;
	}
	// decide which step!
	switch($step) {
		case "1":
		    $activity = $lang['start'];
		    $setup = "<tr><td align=\"center\"><form action=\"". get_link("plugin=repair&step=2") ."\" method=\"post\">".$lang['start_opt'].":<br><br><input type=\"checkbox\" name=\"empty_tmp\" value=\"true\" checked> ".$lang['empty_tmp']."<br><br><input type=\"submit\" name=\"submit\" value=\"".$lang['start']."\"></form></a></td></tr>\n";
		    // parse the template
			$out_array = array(
								"%setup%" => $lang['repair'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
			break;
		case "2":
		    $activity = $lang['optimizing'];
		    $setup .= "<tr><td><p align=\"justify\">".$lang['opt_wait']."</p></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><img src=\"".$template_images_path."loading.gif\" alt=\"".$lang['opt_wait']."\" border=\"0\"></td></tr>\n";
		    $setup .= "<tr><td align=\"center\"><form name=\"message\"><textarea name=\"texts\" cols=\"60\" rows=\"10\"></textarea></form></td></tr>\n";
            $setup .= "<tr><td align=\"center\"><form action=\"". get_link("plugin=admin") ."\" name=\"next\" method=\"post\"><input type=\"submit\" name=\"next_button\" value=\"".$lang['next']."\" disabled></form></td></tr>\n";
            
			// parse the template
			$out_array = array(
								"%setup%" => $lang['edit'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
			
			##### process can start
			// 0: empty tmp- dir
			// 1: deleting useless categories
			// 2: checking all images
			// 3: renaming databases to correct names
			// 4: rename images to fit to the galleries
			
			##### 0: empty tmp- dir
			if (isset($_POST['empty_tmp']) && $_POST['empty_tmp'] == "true") {
				fs_rmdir($tmp_path,false,$not_del_base_files = array(".htaccess","index.html"));
			}
			##### 1: deleting useless categories
			send($lang['del_cat']);
			$cats_ = list_all_empty_cats($gallery_path);
			$max = count($cats_);
			$i = 0;
			while ($i < $max) {
				fs_rmdir($cats_[$i]);
				send(" - ".$lang['removed'].": ".$cats_[$i]);
				$i++;
			}
			
			##### 2: checking all images
			send("\\n\\n".$lang['del_img']);
			
			$images_db = array();
			$images_img = array();
			$images_thumb = array();
			
			// getting all images from databases
		    $i = 0;
        	$max_cats = count($cats);
        	while ($i < $max_cats) {
        		$galleries = list_all_dbs($cats[$i]);
        		$max_galleries = count($galleries);
        		$j = 0;
        		while ($j < $max_galleries) {
        			$fp = file($galleries[$j]);
        			$k = 0;
        			$max_imgs = count($fp);
        			while ($k < $max_imgs) {
        				$row_expl = explode("|",$fp[$k]);
        				$images_db[] = $row_expl[1];
        				$k++;
        			}
        			$j++;
        		}
        		$i++;
        	}
        	// getting all images from img- dir
        	$image_ext = array("gif","jpg","jpeg","png");
    		$dir_handle = opendir($img_path);
    		while ($file = readdir($dir_handle)) {
        		if ($file != "." && $file != ".." && !is_dir($tmp_path.$file)) {
            		$tmp_file = explode(".",$file);
            		$i = 0;
            		while ($i < count($image_ext)) {
                		if ($image_ext[$i] == strtolower($tmp_file[count($tmp_file)-1])) {
							$images_img[] = $file;
                		}
            			$i++;
            		}
        		}
    		}
    		closedir($dir_handle);
    		// getting all images from thumb- dir
    		$dir_handle = opendir($thumb_path);
    		while ($file = readdir($dir_handle)) {
        		if ($file != "." && $file != ".." && !is_dir($tmp_path.$file)) {
            		$tmp_file = explode(".",$file);
            		$i = 0;
            		while ($i < count($image_ext)) {
                		if ($image_ext[$i] == strtolower($tmp_file[count($tmp_file)-1])) {
							$images_thumb[] = $file;
                		}
            			$i++;
            		}
        		}
    		}
    		closedir($dir_handle);
    		// all images collected
    		send(" - ".$lang['all_collected']);
    		
    		// check, if there are any images not used
    		$db_images = count($images_db);
    		// first check the imgs
    		$i = 0;
    		$max = count($images_img);
    		while ($i < $max) {
    			if (!is_in($images_img[$i],$images_db,$db_images)) {
    				unlink($img_path.$images_img[$i]);
    				send(" - ".$lang['removed'].": ".$images_img[$i]);
    			}
    			$i++;
    		}
    		// now, check the thumbs
    		$i = 0;
    		$max = count($images_thumb);
    		while ($i < $max) {
    			if (!is_in($images_thumb[$i],$images_db,$db_images)) {
    				unlink($thumb_path.$images_thumb[$i]);
    				send(" - ".$lang['removed'].": ".$images_thumb[$i]);
    			}
    			$i++;
    		}
    		
    		##### 3+4:
    		send("\\n\\n".$lang['opt_gal_cat']);
    		
    		$i = 0;
        	$max_cats = count($cats);
        	while ($i < $max_cats) {
        		$galleries = list_all_dbs($cats[$i]);
        		$max_galleries = count($galleries);
        		$j = 0;
        		while ($j < $max_galleries) {
        			$fp = file($galleries[$j]);
        			$category = get_category_name($cats[$i]);
        			$gallery = get_gallery_name($galleries[$j]);
        			$akt_filename = $galleries[$j];
        			$c_filename = $gallery_path.$category."/". str_replace(" ","_",strtolower($gallery)) .".dat";
        			if ($akt_filename != $c_filename) {
        				rename($galleries[$j],$c_filename);
        				send(" - ".$lang['renamed'].": ".$galleries[$j]);
        				$galleries[$j] = $c_filename;
        			}
        			$c_name = str_replace(" ","",strip_tags(trim(strtolower(rawurldecode($category))))) ."_". str_replace(" ","",strip_tags(trim(strtolower(rawurldecode($gallery))))) ."_img";
        			$k = 0;
        			$max_imgs = count($fp);
        			while ($k < $max_imgs) {
        				$row_expl = explode("|",$fp[$k]);
        				$k++;
        				$cc_name = $c_name. get_number($k);
        				if (!eregi($cc_name,$row_expl[1])) {
        					repair_db($galleries[$j],$c_name);
        					send(" - ".$lang['repaired'].": ".$galleries[$j]);
        					break;
        				}
        			}
        			$j++;
        		}
        		$i++;
        	}
        	
        	
    		send("\\n\\n".$lang['opt_finished']);
    		echo "<script language=\"JavaScript\" type=\"text/javascript\"> document.next.next_button.disabled = false; </script>";
			flush();
			ob_flush();
		    break;
	}
}

##### should the main script be stopped?
################################################################################
$stop = true;

?>
