<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This plugin contacts the update server and will let   *|
 \*                   your gallery always be actual                         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 09.12.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: update.inc.php                               |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/

##### Code of the setup plugin
################################################################################
define("FS_GALERIE_PLUGIN_UPDATE",$version);

// this script will never end...
// otherwise it is not possible to do a long update process
@set_time_limit(0);

$setup = "<!-- Plugin: Update Wizard for FS Galerie 2.x -->\n\n";

// how many steps will this wizard have?
$steps = 3;

// just for control...
$exit = false;

// before we can start the steps, check whether we are logged in or not
// if so, a "session id" will get created automatically, if you use get_link(string get,[string file]) for all of your links!
login();

// check, if safe_mode is on or not
$safe_mode = (bool) ini_get("safe_mode");
if ($safe_mode) {
	$activity = "Update is getting initialised...";
	$step = 0;
	$setup = "<tr><td align=\"center\">".$lang['safe_mode']."</td></tr>\n";
	$exit = true;
	$out_array = array(
						"%setup%" => $lang['setup'],
						"%url%" => get_link("plugin=admin"),
						"%img_url%" => $template_images_path,
				    	"%version%" => $version,
				    	"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    	"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    	"%step%" => $setup,
				    	"%error_msg%" => $lang['error_msg']
						);
	parse_template("setup.html",$out_array,0);
}

// now, start the steps, if logged in:
if (!$exit && $logged_in) {
	if (!isset($step) || empty($step)) {
		$step = 1;
	}

	// decide which step!
	switch($step) {
		case "1":
		    $activity = $lang['update.start'];
		    
			$setup .= "<tr><td align=\"center\"><form action=\"". get_link("plugin=update&step=2") ."\" method=\"post\"><input type=\"hidden\" name=\"send_but\" value=\"1\">".$lang['update']."<br><br><input type=\"submit\" name=\"submit\" value=\"".$lang['update.button']."\"></form></td></tr>\n";

			// parse the template
			$out_array = array(
								"%setup%" => $lang['update.short'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "2":
		    if ($_POST['send_but'] != "1") {
		    	@header("Location: ". get_link("plugin=update") );
		    }
		    
		    $activity = $lang['update.checking'];
		    
		    $setup .= "<tr><td align=\"center\">".$lang['update.checking_long']."<br><br><img src=\"".$template_images_path."loading.gif\" border=\"0\"></td></tr>\n";
		    $setup .= "<tr><td align=\"center\"><form name=\"message\"><textarea name=\"texts\" cols=\"50\" rows=\"10\"></textarea></form></td><tr>\n";
		    $setup .= "<tr><td align=\"center\"><form name=\"next\" action=\"". get_link("plugin=update&step=3") ."\" method=\"post\"><input type=\"hidden\" name=\"send_but\" value=\"1\"><input type=\"hidden\" name=\"files\" value=\"\"><input type=\"submit\" name=\"submit\" value=\"".$lang['update.install']."\" disabled></form></td></tr>\n";
		    
			// parse the template
			$out_array = array(
								"%setup%" => $lang['update.short'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
			
			##### now, doing the job
			include_once("./lib/update.lib.php");
			// contacting the update server, so we now, if he really exists
			$version = "";
			get($update_server,$version);
			$version = trim($version);
			
			if (empty($version)) {
				send($lang['update.conn_prob']);
            }
            
			// if the servers answer is ok, go on (normal answer would be e.g. 2.0.01, so 6 characters)
			if (strlen($version) == 6) {
				send($lang['update.latest_ver'].": ".$version);
				send($lang['update.your_ver'].": ".$_built);
				send("");
				
				// generell check for new version
				$vers_arr = explode(".",$version);
				$_vers_arr = explode(".",$_built);
				if (($vers_arr[0] > $_vers_arr[0]) || ($vers_arr[1] > $_vers_arr[1]) || ($vers_arr[2] > $_vers_arr[2])) {
					send("!!".$lang['update.new_ver']."!!");
					send("");
				}
				
				// checking the files in detail
				
				// array with a filelist of the newest files generated by update server
				$new_files = array();
				// array with the filelist of local files
				$filelist = array();
				// array with a filelist of files which have to get updated
				$renew_files = array();
				
				// preparing the files send by update server as an as. array
				$files = "";
				get($update_server."&action=filelist",$files);
				$files = trim($files);
				$_files = explode("[filelist]",$files);
				$_files = explode("[/filelist]",$_files[1]);
				$files = $_files[0];
				$files_arr = explode("|&|",$files);
				$i = 0;
				while ($i < count($files_arr)) {
					$tmp_arr = explode("|",$files_arr[$i]);
					$new_files[$tmp_arr[0]] = $tmp_arr[1]."|".$tmp_arr[2];
					$i++;
				}
				
				// now getting the local files into $filelist (see function read_dir())
				read_dir("./");
				
				// now, compare the files
				$msg = "";
				while (list($key,$value) = each($new_files)) {
					if (!empty($key)) {
						if (empty($filelist[$key])) {
							$renew_files[] = $key;
							$msg .= $lang['update.new_ver'].": ".$key."\\n";
						} else {
							// get the version of both files
							$tmp_arr = explode("|",$value);
							$tmp_arr_2 = explode("|",$filelist[$key]);
							$ver_1 = (int) str_replace("#","",$tmp_arr[0]);
							$ver_2 = (int) str_replace("#","",$tmp_arr_2[0]);
						
							// now, compare
							if (eregi("common.inc.php",$key)) {
								if ($ver_1 != $ver_2) {
									$renew_files[] = $key;
									$msg .= $lang['update.new_ver'].": ".$key."\\n";
								}
							} else {
						    	if (($value != $filelist[$key]) && ($ver_1 >= $ver_2) || ($ver_2 > $ver_1)) {
						    		$renew_files[] = $key;
						    		$msg .= $lang['update.new_ver'].": ".$key."\\n";
						    	}
							}
						}
					}
				}
				send($msg);

				// ok, filelist created and send to user, now setting the hidden files field and enable the "install"- button
				$files = implode("|",$renew_files);
				if (empty($files)) {
					echo "<script language=\"JavaScript\" type=\"text/javascript\"> document.next.submit.value = '".$lang['finish']."'; document.next.submit.disabled = false; </script>\n";
					send($lang['update.finish_2']);
				} else {
					echo "<script language=\"JavaScript\" type=\"text/javascript\"> document.next.files.value = '".$files."'; document.next.submit.disabled = false; </script>\n";
					flush();
					ob_flush();
				}
				
			} else {
				send($lang['update.conn_prob']);
			}
		    break;
		case "3":
		    if ($_POST['send_but'] != "1") {
		    	@header("Location: ". get_link("plugin=update") );
		    }
		    
            $activity = $lang['update.installing'];
            
            // are there any files to update??
            if (empty($_POST['files'])) {
            	@header("Location: ". get_link("plugin=admin") );
            	exit();
            }
            
            // read files
            $files = explode("|",$_POST['files']);
            $max_files = count($files);
            
            // create the process bar and the output
            $setup .= "<tr><td>&nbsp;</td></tr>\n";
			$setup .= "<tr><td><p align=\"justify\">".$lang['update.downloading']."</p></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><img src=\"".$template_images_path."loading.gif\" border=\"0\"></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><form name=\"message\"><textarea name=\"texts\" cols=\"50\" rows=\"10\"></textarea></form></td></tr>\n";
			$setup .= "<tr><td align=\"center\" width=\"100%\">
			                <table height=\"20\" width=\"90%\" cellspacing=\"1\" cellpadding=\"0\" class=\"highlight2\">
							<tr>
								<td class=\"normal\">
								<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">
								<tr>";
			$width = round(100 / ($max_files),5);
			$i = 1;
			while ($i <= $max_files) {
				$setup .= "<td id=\"zelle".$i."\" class=\"normal\" width=\"".$width."%\" height=\"20\"></td>\n";
				$i++;
			}

			$setup .= "
			                    </tr>
			                    </table>
								</td>
			                </tr>
			                </table>
			            </td>
					</tr>\n";
			$setup .= "<tr><td align=\"center\"><span id=\"prozent\"><b>0%</b></span><!--<input type=\"text\" name=\"prozent\" value=\"\" size=\"5\" readonly>--></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><form action=\"". get_link("plugin=admin") ."\" name=\"next\" method=\"post\"><input type=\"submit\" name=\"next_button\" value=\"".$lang['finish']."\" disabled></form></td></tr>\n";

            // parse the template
			$out_array = array(
								"%setup%" => $lang['update.short'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
			
			include_once("./lib/update.lib.php");
			// some needed variables for send()
			$all_sends = $max_files;
			$sends = 0;
			
            // download the new files and replace them
            $i = 0;
            while ($i < $max_files) {
            	$file = $files[$i];
            	// write content to $file
            	$_file = "";
            	get($update_server."&action=get&file=".$file,$_file);
            	
            	if (is_writable($file) || !file_exists($file)) {
            		$fp = @fopen($file,"w+");
            		$write = @fwrite($fp,$_file);
            		if (!$write) {
               			send($lang['update.not_updated'].": ".$file,1);
            		} else {
            			send($lang['update.updated'].": ".$file,1);
            		}
            		$fp = @fclose($fp);
            	} else {
            		send($lang['update.no_rights'].": ".$file,1);
            	}
            	$i++;
            }
            
            // make the button visible and set bar to 100%
            echo "<script language=\"JavaScript\" type=\"text/javascript\"> document.next.next_button.disabled = false; set_bar(". $max_files .",". $max_files ."); </script>";
			flush();
			ob_flush();
            
		    break;
	}
}

##### should the main script be stopped?
################################################################################
$stop = true;

?>
