<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: this script will send an image with copyright notice  *|
 \*                   for the eCard System (no permission required)         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 17.05.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: read_mail_image.php                          |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/


$img = rawurldecode($_GET['img']);
$path = rawurldecode($_GET['path']);

// include the configuration, the functions and the copyright
include("./common.inc.php");

// check for $img and $path
if (isset($img) && isset($path) && !empty($img) && !empty($path)) {
  	$read = getimagesize($img);
  	$type = $read[2];

  	// creating the correct image
  	switch($type) {
    	case 1:
      		$img = imagecreatefromgif($img);
      		$mime = "image/gif";
    		break;
    	case 2:
      		$img = imagecreatefromjpeg($img);
      		$mime = "image/jpeg";
    		break;
    	case 3:
      		$img = imagecreatefrompng($img);
      		$mime = "image/png";
    		break;
    }
    
    // now, writing the copyright
    // if your copyright is to long, the text will get cut
    $data = get_image_information($category,$gallery,$img_id);
    $string = $lang['copyright_only']." ". date("Y") ." ". trim($data[5]) ." (". trim($data[6]) .")";
    $chars = strlen($string);
    // set the colours
    $font_colour = imagecolorallocate($img,0,0,0);
    $background_colour = imagecolorallocate($img,255,255,255);
    // get the size of the copyright
	$max_chars_per_row = floor(($read[0]-9)/imagefontwidth(3));
	if ($chars <= $max_chars_per_row) {
    	$width = imagefontwidth(3) * strlen($string) + 9;
    	$height = imagefontheight(3) + 9;
    	// draw the background
    	if ($gd >= 2) {
    		imagefilledrectangle($img,5,5,$width,$height,$background_colour);
    	}
    	// write the text
    	imagestring($img,3,7,7,$string,$font_colour);
    } else {
    	$width = $read[0]-9;
    	$rows = ceil($chars/$max_chars_per_row);
    	$height = imagefontheight(3) * $rows + 9;
    	// draw the background
    	if ($gd >= 2) {
    		imagefilledrectangle($img,5,5,$width,$height,$background_colour);
    	}
    	// write the text
    	for ($i=1;$i<=$rows;$i++) {
    		imagestring($img,3,7,7+($i-1)*imagefontheight(3),substr($string,($i-1)*$max_chars_per_row,$i*$max_chars_per_row),$font_colour);
    	}
    }
    
	// sending the image directly to the browser per header
  	header("Content-Type: $mime");
  	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
  	header("Last-Modified: ". gmdate("D, d M Y H:i:s")." GMT");
  	header("Pragma: no-cache");
  	header("Cache-Control: no-store, no-cache, max-age=0, must-revalidate");
  	
  	// send the prepared image to the browser
  	switch($type) {
    	case 1:
      		imagegif($img);
    		break;
    	case 2:
      		imagejpeg($img);
    		break;
    	case 3:
      		imagepng($img);
    		break;
    }
    
    // destroying the image
    imagedestroy($img);

// no access -> blind.gif *gg*
} else {
  	header("Content-type: image/gif");
  	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
  	header("Last-Modified: " . gmdate("D, d M Y H:i:s") ." GMT");
  	header("Pragma: no-cache");
  	header("Cache-Control: no-store, no-cache, max-age=0, must-revalidate");
  	readfile($path."blind.gif");
}

?>
