<?php

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: The installation script for your gallery              *|
 \*                                                                         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 03.09.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: install.php                                  |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/
       
?>
<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Installation</title>
</head>
<body>
<table width="550" cellspacing="1" cellpadding="3" border="0" align="center">
<tr>
	<th align="center" colspan="2" bgcolor="#CECFCE"><b>Checking your Server and your Environment...</b></th>
</tr>
<?php
$msg = array("true" => "<font color=\"#00FF00\"><b>OK</b></font>","false" => "<font color=\"#FF0000\"><b>ERROR</b></font>");

echo "<tr><th align=\"center\" colspan=\"2\" bgcolor=\"#DEDEDE\">General</th></tr>\n";
// check, if safe_mode is on
$bool_safe_mode = (bool) ini_get("safe_mode");
$safe_mode = ($bool_safe_mode)? $msg['false']." (you won't be able to create new categories and galleries; the gallery itself will work correctly -> set 'safe_mode = Off' in php.ini)" : $msg['true'];
echo "<tr><td align=\"left\" bgcolor=\"#DEDEDE\" width=\"30%\"><b>Safe Mode</b></td><td align=\"center\" bgcolor=\"#EEEEEE\" width=\"70%\">".$safe_mode."</td></tr>\n";

// checking the gd lib
$bool_gd = (bool) extension_loaded("gd");
$gd = ($bool_gd)? $msg['true'] : $msg['false']." (GD will only be used for resizing images; the gallery itself will work correctly -> ask your server administrator for GD Library)";
echo "<tr><td align=\"left\" bgcolor=\"#DEDEDE\" width=\"30%\"><b>GD Library</b></td><td align=\"center\" bgcolor=\"#EEEEEE\" width=\"70%\">".$gd."</td></tr>\n";

echo "<tr><th align=\"center\" colspan=\"2\" bgcolor=\"#DEDEDE\">Directories</th></tr>\n";
// checking the paths
$bool_tmp_path = (bool) (is_readable("./tmp/") && is_writeable("./tmp/"));
$tmp_path = ($bool_tmp_path)? $msg['true'] : $msg['false']." (you won't be able to create new categories and galleries; the gallery itself will work correctly -> set chmod 0777)";
echo "<tr><td align=\"left\" bgcolor=\"#DEDEDE\" width=\"30%\"><b>./tmp/</b></td><td align=\"center\" bgcolor=\"#EEEEEE\" width=\"70%\">".$tmp_path."</td></tr>\n";

$bool_tmp_path = (bool) (is_readable("./data/db/") && is_writeable("./data/db/"));
$tmp_path = ($bool_tmp_path)? $msg['true'] : $msg['false']." (you won't be able to create new categories and galleries; the gallery itself will work correctly -> set chmod 0777)";
echo "<tr><td align=\"left\" bgcolor=\"#DEDEDE\" width=\"30%\"><b>./data/db/</b></td><td align=\"center\" bgcolor=\"#EEEEEE\" width=\"70%\">".$tmp_path."</td></tr>\n";

$bool_tmp_path = (bool) (is_readable("./data/images/") && is_writeable("./data/images/"));
$tmp_path = ($bool_tmp_path)? $msg['true'] : $msg['false']." (you won't be able to create new categories and galleries; the gallery itself will work correctly -> set chmod 0777)";
echo "<tr><td align=\"left\" bgcolor=\"#DEDEDE\" width=\"30%\"><b>./data/images/</b></td><td align=\"center\" bgcolor=\"#EEEEEE\" width=\"70%\">".$tmp_path."</td></tr>\n";

$bool_tmp_path = (bool) (is_readable("./data/thumbnails/") && is_writeable("./data/thumbnails/"));
$tmp_path = ($bool_tmp_path)? $msg['true'] : $msg['false']." (you won't be able to create new categories and galleries; the gallery itself will work correctly -> set chmod 0777)";
echo "<tr><td align=\"left\" bgcolor=\"#DEDEDE\" width=\"30%\"><b>./data/thumbnails/</b></td><td align=\"center\" bgcolor=\"#EEEEEE\" width=\"70%\">".$tmp_path."</td></tr>\n";

echo "<tr><th align=\"center\" colspan=\"2\" bgcolor=\"#DEDEDE\">Files</th></tr>\n";
// checking the files
$bool_tmp_path = (bool) (is_readable("./config.ini") && is_writeable("./config.ini"));
$tmp_path = ($bool_tmp_path)? $msg['true'] : $msg['false']." (you won't be able to edit your gallery by browser; the gallery itself will work correctly -> set chmod 0777)";
echo "<tr><td align=\"left\" bgcolor=\"#DEDEDE\" width=\"30%\"><b>./config.ini</b></td><td align=\"center\" bgcolor=\"#EEEEEE\" width=\"70%\">".$tmp_path."</td></tr>\n";


$bool_tmp_path = (bool) (is_readable("./data/images/.htaccess") && is_writeable("./data/images/.htaccess"));
$tmp_path = ($bool_tmp_path)? $msg['true'] : $msg['false']." (you won't be able to edit your gallery by browser; the gallery itself will work correctly -> set chmod 0777)";
echo "<tr><td align=\"left\" bgcolor=\"#DEDEDE\" width=\"30%\"><b>./data/images/.htaccess</b></td><td align=\"center\" bgcolor=\"#EEEEEE\" width=\"70%\">".$tmp_path."</td></tr>\n";

echo "<tr><th align=\"center\" colspan=\"2\" bgcolor=\"#DEDEDE\">Configuration</th></tr>\n";
// checking the configuration (only the password; maybe I will add sometime something)
@include_once("./config.ini");
$bool_pw = (bool) ($pw == md5("password"));
$pw = ($bool_pw)? $msg['false']." (please change the password after finishing this wizard, because otherwise your gallery can get hacked)" : $msg['true'];
echo "<tr><td align=\"left\" bgcolor=\"#DEDEDE\" width=\"30%\"><b>Password</b></td><td align=\"center\" bgcolor=\"#EEEEEE\" width=\"70%\">".$pw."</td></tr>\n";

// ok, everything was checked
?>
<tr>
	<th align="center" colspan="2" bgcolor="#CECFCE"><input type="button" name="next" value="Finish" onClick="document.location.href='admin.php';"></th>
</tr>
</table>
</body>
</html>
