<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This script contents all needed functions for copying *|
 \*                   and renaming images                                   *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 05.07.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: dbconverter.lib.php                          |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/

##### security: a constant, defined in the plugin "setup"
if (!defined("FS_GALERIE_PLUGIN_DBCONVERTER") || FS_GALERIE_PLUGIN_DBCONVERTER != $version) {
	@header("Location: ".$PHP_SELF);
	exit();
}

##### lists all images of a gallery (v.1.x of FS Galerie)
function list_all_images_from_db($db_file) {
	if (!file_exists($db_file)) {
		return false;
	} else {
		$images = array();
		$fp = fopen($db_file,"r");
		while (!feof($fp)) {
			$row = fgets($fp,4096);
			$info_array = explode("|",$row);
			$images[] = $info_array[3];
		}
		$fp = fclose($fp);
		return $images;
	}
}

##### copy given images from one path to another
function copy_images ($images,$from,$to) {
	if (!is_array($images) || !is_dir($from) || !is_dir($to)) {
		return false;
	} else {
		$all_images = count($images);
		$i = 0;
		while ($i < $all_images) {
			if (file_exists($to.$images[$i])) {
				$rename = true;$old_name = $images[$i];
				rename($from.$old_name,$from."new_".$old_name);
				$images[$i] = "new_".$old_name;
			}
			copy($from.$images[$i],$to.$images[$i]);
			if ($rename) {
				rename($from.$images[$i],$from.$old_name);
			}
			$i++;
		}
		return $images;
	}
}

##### renames all given images
function rename_images ($images,$path,$category,$gallery) {
	if (!is_dir($path) || !is_array($images) || empty($category) || empty($gallery)) {
		return false;
	} else {
		$text = str_replace(" ","",strip_tags(trim(strtolower(rawurldecode($category))))) ."_". str_replace(" ","",strip_tags(trim(strtolower(rawurldecode($gallery)))));
		$all_images = count($images);
		$i = 0;
		while ($i < $all_images) {
			$file = $path.$images[$i];
			if (file_exists($file)) {
				$tmp_file = explode(".",$images[$i]);
				$ext = strtolower($tmp_file[count($tmp_file)-1]);
				$new_file = $text."_img". get_number($i+1) .".".$ext;
				rename($file,$path.$new_file);
				$images[$i] = $new_file;
			}
			$i++;
		}
		return $images;
	}
}

?>
