<?PHP
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This script will rename all images                    *|
 \*                                                                         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 11.06.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: renameimg.class.php                          |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/


class RenameImg {
    ######### properties of this class
    var $autocreate = false; // shall we begin the renaming immediately?
    var $image_ext = array("gif","jpg","jpeg","png"); // available types of images; do not add something!!
    var $image_dir; // the images, which will get renamed
    var $digits = 4; // how many digits will we have?
    var $text; // name of the new image; missing: e.g. _img0001.jpg
    // language options:
    var $rename_success;
    var $rename_no_success;
    
    ######### functions of the class
    ##### lists all images of a path
    function list_all_images() {
        $files = array();
        $dir_handle = opendir($this->image_dir);
        while ($file = readdir($dir_handle)) {
            if ($file != "." && $file != ".." && !is_dir($this->image_dir.$file)) {
                $tmp_file = explode(".",$file);
                $i = 0;
                while ($i < count($this->image_ext)) {
                    if ($this->image_ext[$i] == strtolower($tmp_file[count($tmp_file)-1])) {
                        $files[] = $file;
                    }
                $i++;
                }
            }
        }
        closedir($dir_handle);
        return $files;
    }
    
    ##### renames the images
    function rename_img() {
        $files = array();
        $files = $this->list_all_images();
        $i = 0;
        while ($i < count($files)) {
            $number = $i+1;
            if (strlen($number) < $this->digits) {
                $wieoft = $this->digits - strlen($number);
                $j = 0;
                while ($j < $wieoft) {
                    $number = "0".$number;
                    $j++;
                }
            }
            $ext_arr = explode(".",$files[$i]);
            $ext = strtolower($ext_arr[count($ext_arr)-1]);
            $do = rename($this->image_dir.$files[$i],$this->image_dir.$this->text."_img".$number.".".$ext);
            if ($do) {
            	send(" - ".$files[$i]." ".$this->rename_success."\\n",1);
            } else {
            	send(" - ".$files[$i]." ".$this->rename_no_success."\\n",1);
            }
            $i++;
        }
    }

    ##### constructor of this class
    function RenameImg() {
        if ($this->autocreate) {
            $this->rename_img();
        }
    }
}

#########
## EOF ##
#########

?>
