<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This script contents all needed functions for         *|
 \*                   repairing and optimizing the gallery                  *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 01.09.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: repair.lib.php                               |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/

##### security: a constant, defined in the plugin "setup"
if (!defined("FS_GALERIE_PLUGIN_REPAIR") || FS_GALERIE_PLUGIN_REPAIR != $version) {
	@header("Location: ".$PHP_SELF);
	exit();
}

// checks, if there is an image in the array $in; $max = number of elements in the array
function is_in($element,$in,$max) {
	$i = 0;$bool = false;
	while ($i < $max) {
		if ($in[$i] == $element) {
			$bool = true;
			break;
		}
		$i++;
	}
	return $bool;
}

// lists all empty categories
function list_all_empty_cats($dir) {
    $cats = array();
    $dir_handle = opendir($dir);
    while ($file = readdir($dir_handle)) {
        if (is_dir($dir.$file) && $file != "." && $file != ".." && !exists_gallery($dir.$file."/")) {
			$cats[] = $dir.$file."/";
        }
    }
    closedir($dir_handle);
    return $cats;
}

// rewrites a database
function repair_db($file,$name) {
	global $img_path,$thumb_path;
	$tmp_file = $tmp_path."repair.tmp";
	$fp = fopen($tmp_file,"w");
	$fp2 = file($file);
	$max = count($fp2);
	$i = 0;
	while ($i < $max) {
		$number = $i + 1;
		$digit = get_number($number);
		$info_expl = explode("|",$fp2[$i]);
		$ext_expl = explode(".",$info_expl[1]);
		$ext = $ext_expl[count($ext_expl)-1];
		$new_file_name = $name.$digit.".".$ext;
		rename($img_path.$info_expl[1],$img_path.$new_file_name);
		rename($thumb_path.$info_expl[1],$thumb_path.$new_file_name);
		$info_expl[1] = $new_file_name;
		$info_impl = implode("|",$info_expl);
		fwrite($fp,$info_impl);
		$i++;
	}
	$fp = fclose($fp);
	if (@copy($tmp_file,$file)) {
		unlink($tmp_file);
		return true;
	} else {
		unlink($tmp_file);
		return false;
	}
}

// this function will send a message during executing a script
function send($text) {
	echo "<script language=\"JavaScript\" type=\"text/javascript\"> document.message.texts.value += \"".$text."\\n\"; document.message.texts.focus(); </script>";
	flush();
	ob_flush();
}

?>
