<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This plugin is the central administration             *|
 \*                                                                         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 01.09.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: admin.inc.php                                |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/

##### Code of the setup plugin
################################################################################

$setup = "<!-- Plugin: Admin Area for FS Galerie 2.x -->\n\n";
// first of all, let us collect all information send via POST
// this will not be done by the main file: common.inc.php, so we have to do it
if (!empty($_POST)) {
    extract_vars($_POST, $GLOBALS);
} else if (!empty($HTTP_POST_VARS)) {
    extract_vars($HTTP_POST_VARS, $GLOBALS);
}

// how many steps will this wizard have?
$steps = 1;

// just for control...
$exit = false;

// before we can start the steps, check whether we are logged in or not
// if so, a "session id" will get created automatically, if you use get_link(string get,[string file]) for all of your links!
login();

// now, start the steps, if logged in:
if (!$exit && $logged_in) {
	$msg = "";
	// origin links to the plugins
	$zip_link = "<a href=\"". get_link("plugin=zip&step=1") ."\"><img src=\"".$template_images_path."zip_upload.gif\" border=\"0\" alt=\"".$lang['upload_zip']."\"></a>";
	$setup_link = "<a href=\"". get_link("plugin=setup&step=1") ."\"><img src=\"".$template_images_path."new_gallery.gif\" border=\"0\" alt=\"".$lang['new_gallery']."\"></a>";
	$dbconverter_link = "<a href=\"". get_link("plugin=dbconverter&step=1") ."\"><img src=\"".$template_images_path."convert.gif\" border=\"0\" alt=\"".$lang['convert']."\"></a>";
	$update_link = "<a href=\"". get_link("plugin=update&step=1") ."\"><img src=\"".$template_images_path."update.gif\" border=\"0\" alt=\"".$lang['update']."\"></a>";
	$safe_mode = (bool) ini_get("safe_mode");
	if ($safe_mode) {
		$msg = $lang['safe_mode'];
		// new link to plugins, if safe_mode = On!!!
		$zip_link = "<img src=\"".$template_images_path."zip_upload.gif\" border=\"0\" alt=\"".$lang['upload_zip']."\">";
		$setup_link = "<img src=\"".$template_images_path."new_gallery.gif\" border=\"0\" alt=\"".$lang['new_gallery']."\">";
		$dbconverter_link = "<img src=\"".$template_images_path."convert.gif\" border=\"0\" alt=\"".$lang['convert']."\">";
		$update_link = "<img src=\"".$template_images_path."update.gif\" border=\"0\" alt=\"".$lang['update']."\"></a>";
	}
	$setup = "
	        <tr>
	            <td align=\"center\" width=\"120\"><a href=\"". get_link("plugin=config&step=1") ."\"><img src=\"".$template_images_path."config.gif\" border=\"0\" alt=\"".$lang['config']."\"></a></td>
	            <td width=\"*\"><p align=\"justify\"><b>".$lang['config']."</b></p></td>
	            <td align=\"center\" width=\"120\">".$update_link."</td>
	            <td width=\"*\"><p align=\"justify\"><b>".$lang['update']."</b></p></td>
			</tr>
	        <tr>
	            <td align=\"center\" width=\"120\">".$setup_link."</td>
	            <td width=\"*\"><p align=\"justify\"><b>".$lang['new_gallery']."</b></p></td>
	            <td align=\"center\" width=\"120\">".$zip_link."</td>
	            <td width=\"*\"><p align=\"justify\"><b>".$lang['upload_zip']."</b></p></td>
			</tr>
			<tr>
			    <td align=\"center\" width=\"120\"><a href=\"". get_link("plugin=edit&step=1") ."\"><img src=\"".$template_images_path."edit.gif\" border=\"0\" alt=\"".$lang['edit_gallery']."\"></a></td>
	            <td width=\"*\"><p align=\"justify\"><b>".$lang['edit_gallery']."</b></p></td>
	            <td align=\"center\" width=\"120\">".$dbconverter_link."</td>
	            <td width=\"*\"><p align=\"justify\"><b>".$lang['convert']."</b></p></td>
			</tr>
			<tr>
	            <td align=\"center\" width=\"120\"><a href=\"". get_link("plugin=repair&step=1") ."\"><img src=\"".$template_images_path."repair.gif\" border=\"0\" alt=\"".$lang['repair_gallery']."\"></a></td>
	            <td width=\"*\"><p align=\"justify\"><b>".$lang['repair_gallery']."</b></p></td>
	            <td align=\"center\" width=\"120\"><a href=\"". get_link("action=logout") ."\"><img src=\"".$template_images_path."logout.gif\" border=\"0\" alt=\"".$lang['logout']."\"></a></td>
	            <td width=\"*\"><p align=\"justify\"><b>".$lang['logout']."</b></p></td>
			</tr>\n";
	
    // parse the template
	$out_array = array(
	                    "%setup%" => $lang['admin'],
	                    "%msg%" => $msg,
						"%url%" => get_link("plugin=admin&pwd=".$check_pwd),
						"%img_url%" => $template_images_path,
				    	"%version%" => $version,
				    	"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    	"%step%" => $setup,
				    	"%error_msg%" => $lang['error_msg']
						);
	parse_template("admin.html",$out_array,0);
}

##### should the main script be stopped?
################################################################################
$stop = true;

?>
