<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This plugin will convert old 1.x databases to 2.x     *|
 \*                                                                         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 05.07.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: dbconverter.inc.php                          |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/

##### Code of the setup plugin
################################################################################

// this script will never end...
// otherwise it is not possible to create large galleries, because of max_execution_time
@set_time_limit(0);

$setup = "<!-- Plugin: DBConvert Wizard for FS Galerie 2.x -->\n\n";
// first of all, let us collect all information send via POST
// this will not be done by the main file: common.inc.php, so we have to do it
if (!empty($_POST)) {
    extract_vars($_POST, $GLOBALS);
} else if (!empty($HTTP_POST_VARS)) {
    extract_vars($HTTP_POST_VARS, $GLOBALS);
}

// how many steps will this wizard have?
$steps = 4;

// just for control...
$exit = false;

// before we can start the steps, check whether we are logged in or not
// if so, a "session id" will get created automatically, if you use get_link(string get,[string file]) for all of your links!
login();

// check, if safe_mode is on or not
$safe_mode = (bool) ini_get("safe_mode");
if ($safe_mode) {
	$activity = "Setup is getting initialised...";
	$step = 0;
	$setup = "<tr><td align=\"center\">".$lang['safe_mode']."</td></tr>\n";
	$exit = true;
	$out_array = array(
						"%setup%" => $lang['setup'],
						"%url%" => get_link("plugin=admin"),
						"%img_url%" => $template_images_path,
				    	"%version%" => $version,
				    	"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    	"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    	"%step%" => $setup,
				    	"%error_msg%" => $lang['error_msg']
						);
	parse_template("setup.html",$out_array,0);
}

// now, start the steps, if logged in:
if (!$exit && $logged_in) {
	if (!isset($step) || empty($step)) {
		$step = 1;
	}
	// decide which step!
	switch($step) {
		case "1":
		    // getting general information: category, gallery, widths&heights etc.
		    $activity = $lang['general'];
		    $setup .= "
		            <tr>
		                <td colspan=\"2\" align=\"center\"><form action=\"". get_link("plugin=dbconverter&step=2") ."\" method=\"post\"><b><span class=\"error\">". rawurldecode($msg) ."</span></b></td>
					</tr>
					<tr>
		                <td align=\"right\"><b>".$lang['existing_cat'].":</b></td>
		                <td align=\"left\"><select name=\"category_select\" size=\"1\">
		                    <option value=\"new\">".$lang['new_cat']."</option>";
			for($i=0;$i<count($cats);$i++) {
				$cat = get_category_name($cats[$i]);
				$setup .= "
							<option value=\"".$cat."\">".$cat."</option>";
			}
			$setup .= "
			            </select></td>
					</tr>
					<tr>
					    <td align=\"right\"><b>".$lang['new_cat'].":</b></td>
					    <td align=\"left\"><input type=\"text\" size=\"40\" name=\"category_input\" value=\"". rawurldecode($category_input) ."\"></td>
					</tr>
    				<tr>
					    <td align=\"right\"><b>".$lang['db_path'].":</b></td>
					    <td align=\"left\"><input type=\"text\" size=\"40\" name=\"db_path\" value=\"". rawurldecode($db_path) ."\"></td>
					</tr>
    				<tr>
					    <td align=\"right\"><b>".$lang['img_path'].":</b></td>
					    <td align=\"left\"><input type=\"text\" size=\"40\" name=\"images_path\" value=\"". rawurldecode($images_path) ."\"></td>
					</tr>
    				<tr>
					    <td align=\"right\"><b>".$lang['thumb_path'].":</b></td>
					    <td align=\"left\"><input type=\"text\" size=\"40\" name=\"thumbnails_path\" value=\"". rawurldecode($thumbnails_path) ."\"></td>
					</tr>
					<tr>
					    <td align=\"center\" colspan=\"2\"><input type=\"submit\" name=\"next\" value=\"".$lang['next']."\"></form></td>
					</tr>\n";
					
			// parse the template
			$out_array = array(
								"%setup%" => $lang['dbconverter'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "2":
		    // 1: Rename; 2: Resize the big pictures; 3: Resize the thumbnails
		    $activity = $lang['rename_copy'];
		    ##### checking the data
		    // the category
		    $category = trim(strip_tags($category_select));
		    if ($category_select == "new") {
		    	$category = trim(strip_tags($category_input));
		    }
		    $old = "&category=". rawurlencode($category) ."&category_input=". rawurlencode($category_input) ."&db_path=". rawurlencode($db_path) ."&images_path=". rawurlencode($images_path) ."&thumbnails_path=". rawurlencode($thumbnails_path);
		    if ($category == "new" || empty($category)) {
		    	@header("Location: ". get_link("plugin=dbconverter&step=1&msg=". rawurlencode($lang['wrong_cat']) .$old) );
		    	exit();
		    }
			// check, whether there are images inside the dirs and whether they exists
			if (!file_exists($db_path)) {
    			@header("Location: ". get_link("plugin=dbconverter&step=1&msg=". rawurlencode($lang['dbc_no_db']) .$old) );
    			exit();
			}
			// check whether the ending slash is available; if not, add it
			if (substr($images_path,-1) != "/") {
				$images_path = $images_path."/";
			}
			if (substr($thumbnails_path,-1) != "/") {
				$thumbnails_path = $thumbnails_path."/";
			}
			// check goes on...
			if (is_dir($images_path) && is_dir($thumbnails_path)) {
				$image_ext = array("gif","jpg","jpeg","png");
    			$dir_handle = opendir($images_path);
    			while ($file = readdir($dir_handle)) {
        			if ($file != "." && $file != ".." && !is_dir($tmp_path.$file)) {
            			$tmp_file = explode(".",$file);
            			$i = 0;
            			while ($i < count($image_ext)) {
                			if ($image_ext[$i] == strtolower($tmp_file[count($tmp_file)-1])) {
                    			$ok = true;
                    			break;
                			}
            				$i++;
            			}
            			if ($ok) {
            				break;
            			}
        			}
    			}
    			closedir($dir_handle);
    			$dir_handle = opendir($thumbnails_path);
    			while ($file = readdir($dir_handle)) {
        			if ($file != "." && $file != ".." && !is_dir($tmp_path.$file)) {
            			$tmp_file = explode(".",$file);
            			$i = 0;
            			while ($i < count($image_ext)) {
                			if ($image_ext[$i] == strtolower($tmp_file[count($tmp_file)-1])) {
                    			$ok = true;
                    			break;
                			}
            				$i++;
            			}
            			if ($ok) {
            				break;
            			}
        			}
    			}
    			closedir($dir_handle);
    			if (!$ok) {
    				@header("Location: ". get_link("plugin=dbconverter&step=1&msg=". rawurlencode($lang['dbc_no_files']) .$old) );
    				exit();
    			}
			} else {
				@header("Location: ". get_link("plugin=dbconverter&step=1&msg=". rawurlencode($lang['dbc_no_directory']) .$old) );
   				exit();
			}
		    // getting the gallery-name
			if (file_exists($db_path)) {
				$fp = fopen($db_path,"r");
				$row = fgets($fp,4096);
				$row_array = explode("|",$row);
				$gallery = $row_array[4];
				$fp = fclose($fp);
			}
			// everything seems to be o.k., so start the process
			// first: create a new category if necessary
			if ($category_select == "new") {
				// does the dir already exists? if so, we do not have to create it!
				if (!is_dir($gallery_path.$category)) {
					$old_umask = umask(0);
					$bool_dir = @mkdir($gallery_path.$category,0777);
					umask($old_umask);
					// copying the index.html, so nobody can acces the directory, if .htaccess is not supported
					@copy($data_path."index.html",$gallery_path.$category."/index.html");
				} else {
					$bool_dir = true;
				}
				if ($bool_dir) {
					$setup .= "<tr><td align=\"center\"><b>".$lang['path_created']."</b></td></tr>\n";
				} else {
					$setup .= "<tr><td align=\"center\"><b><span class=\"error\">".$lang['path_not_created']."</span></b></td></tr>\n";
				}
			}
			// does this gallery already exists??
			if (is_gallery($gallery_path.$category."/",$gallery)) {
				$i = 2;
				$gallery_new = $gallery." (".$i.")";
				while (is_gallery($gallery_path.$category."/",$gallery_new)) {
					$gallery_new = $gallery." (".$i.")";
					$i++;
				}
				$gallery = $gallery_new;
			}
			// status
			$setup .= "<tr><td>&nbsp;</td></tr>\n";
			$setup .= "<tr><td><p align=\"justify\">".$lang['wait']."</p></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><img src=\"".$template_images_path."loading.gif\" alt=\"".$lang['wait']."\" border=\"0\"></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><form name=\"message\"><textarea name=\"texts\" cols=\"50\" rows=\"10\"></textarea></form></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><form action=\"". get_link("plugin=dbconverter".$old."&gallery=". rawurlencode($gallery) ."&step=3") ."\" name=\"next\" method=\"post\"><input type=\"hidden\" name=\"send_but\" value=\"true\"><input type=\"hidden\" name=\"files\" value=\"\"><input type=\"submit\" name=\"next_button\" value=\"".$lang['next']."\" disabled></form></td></tr>\n";

			// parse the template
			$out_array = array(
								"%setup%" => $lang['dbconverter'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
			flush();
			ob_flush();
			
			
			// this will copy and rename all images
			define("FS_GALERIE_PLUGIN_DBCONVERTER",$version);
			include("./lib/dbconverter.lib.php");
			
			// preparing the images
			$all_files = list_all_images_from_db($db_path);
			
			##### the normal images
			// copying...
			$all_files_2 = copy_images($all_files,$images_path,$img_path);
			echo "<script language=\"JavaScript\" type=\"text/javascript\"> document.message.texts.value += \" - ".$lang['dbc_copy']."\\n\"; document.message.texts.focus(); </script>";
			flush();
			ob_flush();
			// renaming...
			$renamed_files = rename_images($all_files_2,$img_path,$category,$gallery);
			echo "<script language=\"JavaScript\" type=\"text/javascript\"> document.message.texts.value += \" - ".$lang['dbc_rename']."\\n\"; document.message.texts.focus(); </script>";
			flush();
			ob_flush();
			
			##### the thumbnails
			// copying...
			$all_files_2 = copy_images($all_files,$thumbnails_path,$thumb_path);
			echo "<script language=\"JavaScript\" type=\"text/javascript\"> document.message.texts.value += \" - ".$lang['dbc_copy']."\\n\"; document.message.texts.focus(); </script>";
			flush();
			ob_flush();
			// renaming...
			$renamed_files = rename_images($all_files_2,$thumb_path,$category,$gallery);
			echo "<script language=\"JavaScript\" type=\"text/javascript\"> document.message.texts.value += \" - ".$lang['dbc_rename']."\\n\"; document.message.texts.focus(); </script>";
			flush();
			ob_flush();
			
			##### going to the next step:
			$files_imploded = rawurlencode(implode("|",$renamed_files));
			echo "<script language=\"JavaScript\" type=\"text/javascript\"> document.next.files.value = \"".$files_imploded."\"; document.next.next_button.disabled = false; </script>";
			flush();
			ob_flush();
		    break;
		case "3":
		    // collecting the information for every picture
		    $activity = $lang['collecting_info'];
		    if (!$send_but) {
		    	@header("Location: ". get_link("plugin=dbconverter") );
		    	exit();
		    }
		    // the images
		    $files = rawurldecode($files);
		    $files_imploded = $files;
		    $files = explode("|",$files);
		    // the form and the images
		    $max = count($files);
		    $setup .= "<tr><td colspan=\"2\"><form action=\"javascript:setall();\" name=\"setall\"></td></tr>\n";
		    $setup .= "
		                <tr>
		                    <td align=\"right\"><b>".$lang['photographer'].":</b></td>
		                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"copy_all\" value=\"\"></td>
						</tr>
						<tr>
						    <td align=\"right\"><b>".$lang['email'].":</b></td>
						    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"email_all\" value=\"\"></td>
						</tr>
						<tr>
						    <td colspan=\"2\" align=\"center\"><input type=\"submit\" name=\"submit\" value=\"".$lang['set']."\"></form></td>
						</tr>
						<tr>
							<td colspan=\"2\"><hr></td>
						</tr>\n";
		    $setup .= "<tr><td colspan=\"2\"><form name=\"information\" onSubmit=\"return check()\" action=\"". get_link("plugin=dbconverter&step=4&category=".$category."&gallery=".$gallery) ."\" method=\"post\"></td></tr>\n";
		    $info = file($db_path);
		    $i = 0;
		    while ($i < $max) {
		    	$info_exploded = explode("|",$info[$i]);
		    	$setup .= "
		    	            <tr>
		    	                <td align=\"left\" valign=\"middle\"><img src=\"".$thumb_path.$files[$i]."\" border=\"0\" alt=\"\"></td>
		    	                <td align=\"center\">
		    	                <table width=\"100%\" cellspacing=\"0\" cellpadding=\"5\">
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['title'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$i."][title]\" value=\"".$info_exploded[5]."\"></td>
								</tr>
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['description'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$i."][description]\" value=\"".$info_exploded[6]."\"></td>
								</tr>
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['photographer'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$i."][copy]\" value=\"\">*</td>
								</tr>
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['email'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$i."][copy_email]\" value=\"\">*</td>
								</tr>
								</table>
								</td>
							</tr>
							<tr>
							    <td colspan=\"2\"><hr></td>
							</tr>\n";
		    	$i++;
		    }
		    $setup .= "<tr><td align=\"center\" colspan=\"2\"><input type=\"hidden\" name=\"final\" value=\"true\"><input type=\"hidden\" name=\"images\" value=\"".$max."\"><input type=\"hidden\" name=\"files\" value=\"".$files_imploded."\"><input type=\"submit\" name=\"submit\" value=\"".$lang['finish']."\"></form></td></tr>\n";
			// parse the template
			$out_array = array(
								"%setup%" => $lang['dbconverter'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "4":
		    // writing the database -> success message
		    $activity = $lang['creating_gallery'];
		    if (!$final) {
		    	@header("Location: ". get_link("plugin=dbconverter") );
		    	exit();
		    }
		    $files = explode("|",$files);
		    $filename = strip_tags(trim(strtolower(str_replace(" ","_",rawurldecode($gallery))))).".dat";
		    $fp = fopen($gallery_path. rawurldecode($category) ."/".$filename,"w");
		    $i = 0;
		    while ($i < $images) {
		    	if (empty($info[$i]['description'])) {
		    		$desc = "xxx";
		    	} else {
		    		$desc = $info[$i]['description'];
		    	}
		    	$break = ($i < $images-1) ? "\n" : "";
		    	$fileinfo = get_number($i+1)."|".$files[$i]."|". rawurldecode($gallery) ."|".$info[$i]['title']."|".$desc."|".$info[$i]['copy']."|".$info[$i]['copy_email'].$break;
		    	fwrite($fp,$fileinfo);
		    	$i++;
		    }
		    $fp = fclose($fp);
			$setup .= "<tr><td align=\"center\"><a href=\"". get_link("plugin=admin") ."\"><b>".$lang['finished']."</b></a></td></tr>\n";
		    // parse the template
			$out_array = array(
								"%setup%" => $lang['dbconverter'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
	}
}

##### should the main script be stopped?
################################################################################
$stop = true;

?>
