<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This plugin will let you edit and remove galleries    *|
 \*                   and categories                                        *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 01.09.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: edit.inc.php                                 |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/

##### Code of the setup plugin
################################################################################
// include some libs; ATTENTION: setup.inc.php will get included by index.php,
// so you have to include the libs with the path "./lib/"!!!
define("FS_GALERIE_PLUGIN_EDIT",$version);
include("./lib/edit.lib.php");

$setup = "<!-- Plugin: Edit Wizard for FS Galerie 2.x -->\n\n";
// first of all, let us collect all information send via POST
// this will not be done by the main file: common.inc.php, so we have to do it
if (!empty($_POST)) {
    extract_vars($_POST, $GLOBALS);
} else if (!empty($HTTP_POST_VARS)) {
    extract_vars($HTTP_POST_VARS, $GLOBALS);
}

// how many steps will this wizard have?
$steps = 3;

// just for control...
$exit = false;

// before we can start the steps, check whether we are logged in or not
// if so, a "session id" will get created automatically, if you use get_link(string get,[string file]) for all of your links!
login();


// now, start the steps, if logged in:
if (!$exit && $logged_in) {
	if (!isset($step) || empty($step)) {
		$step = 1;
	}
	// decide which step!
	switch($step) {
		case "1":
		    $activity = $lang['edit_show'];
		    // show all categories with all galleries
		    $_cats = list_all_cats($gallery_path,1);
		    $i = 0;
        	$max_cats = count($_cats);
        	while ($i < $max_cats) {
        		$category_name = get_category_name($_cats[$i]);
        		$setup .= "
					<tr>
						<td class=\"highlight\" align=\"left\" colspan=\"2\" width=\"85%\"><img src=\"".$template_images_path."cat.gif\">&nbsp;<b>".$category_name."</b></td>
						<td class=\"highlight\" align=\"right\" width=\"15%\"><a href=\"". get_link("plugin=edit&step=2a&cat=". rawurlencode($category_name) ) ."\"><img src=\"".$template_images_path."edit_small.gif\" border=\"0\" alt=\"".$lang['edit']."\"></a>&nbsp;<a href=\"". get_link("plugin=edit&step=2b&cat=". rawurlencode($category_name) ) ."\"><img src=\"".$template_images_path."delete.gif\" border=\"0\" alt=\"".$lang['delete']."\"></a></td>
					</tr>\n";
        		$galleries = list_all_dbs($_cats[$i]);
        		$max_galleries = count($galleries);
        		$j = 0;
        		while ($j < $max_galleries) {
        			$class2 = "normal2";
        			if ($j % 2 == 0) {
        				$class2 = "normal";
        			}
        			$gallery_name = get_gallery_name($galleries[$j]);
        			$setup .= "
					<tr>
						<td class=\"normal\" width=\"10%\">&nbsp;</td>
						<td class=\"".$class2."\" align=\"left\" width=\"75%\"><img src=\"".$template_images_path."dot.gif\">&nbsp;".$gallery_name."</td>
						<td class=\"".$class2."\" align=\"right\" width=\"15%\"><a href=\"". get_link("plugin=edit&step=2e&cat=". rawurlencode($category_name) ."&gal=". rawurlencode($gallery_name) ) ."\"><img src=\"".$template_images_path."move.gif\" border=\"0\" alt=\"".$lang['move']."\"></a>&nbsp;<a href=\"". get_link("plugin=edit&step=2c&cat=". rawurlencode($category_name) ."&gal=". rawurlencode($gallery_name) ) ."\"><img src=\"".$template_images_path."edit_small.gif\" border=\"0\" alt=\"".$lang['edit']."\"></a>&nbsp;<a href=\"". get_link("plugin=edit&step=2d&cat=". rawurlencode($category_name) ."&gal=". rawurlencode($gallery_name) ) ."\"><img src=\"".$template_images_path."delete.gif\" border=\"0\" alt=\"".$lang['delete']."\"></a></td>
					</tr>\n";
        			$j++;
        		}
        		if ($max_galleries == 0) {
        			$setup .= "
					<tr>
						<td class=\"normal\" width=\"10%\">&nbsp;</td>
						<td class=\"normal\" align=\"left\" width=\"90%\" colspan=\"2\"><img src=\"".$template_images_path."dot.gif\">&nbsp;".$lang['no_gallery']."</td>
					</tr>\n";
        		}
        		$i++;
        	}
        	
			// parse the template
			$out_array = array(
								"%setup%" => $lang['edit'],
								"%url%" =>  get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "2a":
		    // setting the activity
		    $activity = $lang['edit_cat'];
			if (empty($_GET['cat'])) {
				send_error(0);
			}
			$setup = "
			        <tr>
					    <td colspan=\"2\"><form action=\"". get_link("plugin=edit&step=3a") ."\" method=\"post\"><input type=\"hidden\" name=\"send_but\" value=\"1\"><input type=\"hidden\" name=\"old_cat\" value=\"".$_GET['cat']."\"></td>
					</tr>
			        <tr>
			            <td align=\"right\"><b>".$lang['cat_name'].":</b></td><td align=\"left\"><input type=\"text\" size=\"30\" name=\"cat_name\" value=\"".$_GET['cat']."\"></td>
					<tr>
					<tr>
					    <td colspan=\"2\" align=\"center\"><input type=\"submit\" name=\"submit\" value=\"".$lang['submit']."\">&nbsp;<input type=\"reset\" name=\"reset\" value=\"".$lang['reset']."\"></form></td>
					</tr>\n";
		    // parse the template
			$out_array = array(
								"%setup%" => $lang['edit'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
        case "2b":
        	// setting the activity
		    $activity = $lang['remove'];
		    $setup = "
		            <tr>
		                <td align=\"center\"><b>".$lang['remove_cat']."(". rawurldecode($_GET['cat']) .")</b><br><br><a href=\"". get_link("plugin=edit&step=3b&cat=".$_GET['cat'] ) ."\">".$lang['yes']."</a> or <a href=\"". get_link("plugin=edit") ."\">".$lang['no']."</a></td>
					</tr>\n";
		    // parse the template
			$out_array = array(
								"%setup%" => $lang['edit'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "2c":
			if (empty($_GET['cat']) || empty($_GET['gal'])) {
				send_error(0);
			}
		    // collecting the information for every picture
		    $activity = $lang['collecting_info'];
		    // the form and the images
		    $path = $gallery_path. rawurldecode($_GET['cat']) ."/";
	    	if (!is_dir($path)) {
				send_error(1);
			}
		    $gal = rawurldecode($_GET['gal']);
		    $galleries = list_all_dbs($path);
		    $setup .= "<tr><td colspan=\"2\"><form name=\"information\" onSubmit=\"return check_edit()\" action=\"". get_link("plugin=edit&step=3c&cat=".$_GET['cat'] ) ."\" method=\"post\"></td></tr>\n";
		    $setup .= "
						<tr>
						    <td align=\"right\"><b>".$lang['gallery'].":</b></td>
						    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"gal\" value=\"".$gal."\"></td>
						</tr>
						<tr>
							<td colspan=\"2\"><hr></td>
						</tr>\n";
	    	$i = 0;
	    	$max_galleries = count($galleries);
	    	while ($i < $max_galleries) {
	    		// search for the correct gallery
	    		if ($gal == get_gallery_name($galleries[$i])) {
	    			$file = $galleries[$i];
		    		$info = file($file);
		    		$max = count($info);
		    		$j = 0;
		    		while ($j < $max) {
		    			$info_exploded = explode("|",$info[$j]);
		    			$setup .= "
		    	            <tr>
		    	                <td align=\"left\" valign=\"middle\"><img src=\"".$thumb_path.$info_exploded[1]."\" border=\"0\" alt=\"\"></td>
		    	                <td align=\"center\">
		    	                <table width=\"100%\" cellspacing=\"0\" cellpadding=\"5\">
		    	                <tr><td colspan=\"2\"><input type=\"hidden\" name=\"info[".$j."][file]\" value=\"".$info_exploded[1]."\"></td></tr>
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['title'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$j."][title]\" value=\"".$info_exploded[3]."\"></td>
								</tr>
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['description'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$j."][description]\" value=\"".$info_exploded[4]."\"></td>
								</tr>
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['photographer'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$j."][copy]\" value=\"".$info_exploded[5]."\">*</td>
								</tr>
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['email'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$j."][copy_email]\" value=\"". $info_exploded[6] ."\">*</td>
								</tr>
								<tr>
		    	                    <td align=\"right\"><b>".$lang['q_delete']."</b></td>
		    	                    <td align=\"left\"><input type=\"radio\" size=\"30\" name=\"info[".$j."][remove]\" value=\"1\">".$lang['yes']."&nbsp;<input type=\"radio\" size=\"30\" name=\"info[".$j."][remove]\" value=\"0\" checked>".$lang['no']."</td>
								</tr>
								</table>
								</td>
							</tr>
							<tr>
							    <td colspan=\"2\"><hr></td>
							</tr>\n";
		    			$j++;
		    		}
		    		break;
		    	}
		    	$i++;
		    }
		    $setup .= "<tr><td align=\"center\" colspan=\"2\"><input type=\"hidden\" name=\"old_gallery_file\" value=\"".$file."\"><input type=\"hidden\" name=\"final\" value=\"true\"><input type=\"hidden\" name=\"images\" value=\"".$max."\"><input type=\"hidden\" name=\"files\" value=\"".$files_imploded."\"><input type=\"submit\" name=\"submit\" value=\"".$lang['finish']."\"></form></td></tr>\n";
			// parse the template
			$out_array = array(
								"%setup%" => $lang['edit_plugin'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
        case "2d":
            // setting the activity
            $activity = $lang['remove'];
		    $setup = "
		            <tr>
		                <td align=\"center\"><b>".$lang['remove_gal']."(". rawurldecode($_GET['gal']) .")</b><br><br><a href=\"". get_link("plugin=edit&step=3d&cat=".$_GET['cat']."&gal=".$_GET['gal'] ) ."\">".$lang['yes']."</a> or <a href=\"". get_link("plugin=edit") ."\">".$lang['no']."</a></td>
					</tr>\n";
		    // parse the template
			$out_array = array(
								"%setup%" => $lang['edit'],
								"%url%" =>  get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "2e":
		    // setting the activity
            $activity = $lang['moving'];
            
            // the select area with all categories
            $_cats = list_all_cats($gallery_path,1);
            $select = "<select name=\"move_to\" size=\"1\">\n";
            $i = 0;
            while ($i < count($_cats)) {
            	$_cat = get_category_name($_cats[$i]);
            	if ($_cat != rawurldecode($_GET['cat'])) {
            		$select .= "<option value=\"".$_cats[$i]."\">".$_cat."</option>\n";
            	}
            	$i++;
            }
            $select .= "</select>\n";
            
            // the whole form...
            $setup = "
            <tr>
                <td align=\"center\"><form name=\"move\" action=\"". get_link("plugin=edit&step=3e&cat=".$_GET['cat']."&gal=".$_GET['gal'] ) ."\" method=\"post\"><b>".$lang['move_to']."<br>(". rawurldecode($_GET['cat']) .">". rawurldecode($_GET['gal']) ."):</b><br><br>".$select."</td>
            </tr>
            <tr>
                <td align=\"center\"><input type=\"hidden\" name=\"send_but\" value=\"1\"><input type=\"submit\" name=\"move\" value=\"".$lang['move']."\"></form></td>
            </tr>\n";
            
			// parse the template
			$out_array = array(
								"%setup%" => $lang['edit'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "3a":
		    // setting the activity
		    $activity = $lang['save'];
			if ($_POST['send_but'] != 1) {
				@header("Location: ". get_link("plugin=edit") );
				exit();
			}
			if (@rename($gallery_path.$_POST['old_cat'],$gallery_path.$_POST['cat_name'])) {
				$setup .= "<tr><td align=\"center\"><a href=\"". get_link("plugin=edit") ."\"><b>".$lang['updated']."</b></a></td></tr>\n";
			} else {
				$setup .= "<tr><td align=\"center\"><a href=\"". get_link("plugin=edit") ."\"><b>".$lang['not_updated']."</b></a></td></tr>\n";
			}
		    // parse the template
			$out_array = array(
								"%setup%" => $lang['edit'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
        case "3b":
            // setting the activity
		    $activity = $lang['delete_cat'];
			if (empty($_GET['cat'])) {
				send_error(0);
			}
			$cat = rawurldecode($_GET['cat']);
			if (delete_category($cat)) {
				$setup .= "<tr><td align=\"center\"><a href=\"". get_link("plugin=edit") ."\"><b>".$lang['updated']."</b></a></td></tr>\n";
			} else {
				$setup .= "<tr><td align=\"center\"><a href=\"". get_link("plugin=edit") ."\"><b>".$lang['not_updated']."</b></a></td></tr>\n";
			}
		    // parse the template
			$out_array = array(
								"%setup%" => $lang['edit'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "3c":
		    // writing the database -> success message
		    $activity = $lang['creating_gallery'];
		    if (!$_POST['final']) {
		    	@header("Location: ". get_link("plugin=edit") );
		    	exit();
		    }
		    $images = count($info);
		    $new_file = $_POST['old_gallery_file'];
		    $fp = fopen($new_file,"w");
		    $i = 0;
		    while ($i < $images) {
		    	if ($info[$i]['remove'] == 0) {
		    		if (empty($info[$i]['description'])) {
		    			$desc = "xxx";
		    		} else {
		    			$desc = $info[$i]['description'];
		    		}
		    		$break = ($i < $images-1) ? "\n" : "";
		    		$fileinfo = get_number($i+1)."|".$info[$i]['file']."|". rawurldecode($_POST['gal']) ."|".$info[$i]['title']."|".$desc."|".$info[$i]['copy']."|".$info[$i]['copy_email'].$break;
		    		fwrite($fp,$fileinfo);
		    	} else {
		    		unlink($img_path.$info[$i]['file']);
		    		unlink($thumb_path.$info[$i]['file']);
		    	}
		    	$i++;
		    }
		    $fp = fclose($fp);
			$setup .= "<tr><td align=\"center\"><a href=\"". get_link("plugin=edit") ."\"><b>".$lang['updated']."</b></a></td></tr>\n";
		    // parse the template
			$out_array = array(
								"%setup%" => $lang['dbconverter'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
        case "3d":
            // setting the activity
		    $activity = $lang['delete_gal'];
			if (empty($_GET['cat']) || empty($_GET['gal'])) {
				send_error(0);
			}
			$path = $gallery_path. rawurldecode($_GET['cat']) ."/";
	    	if (!is_dir($path)) {
				send_error(1);
			}
		    $gal = rawurldecode($_GET['gal']);
		    $galleries = list_all_dbs($path);
	    	$i = 0;
	    	$max_galleries = count($galleries);
	    	while ($i < $max_galleries) {
	    		// search for the correct gallery
	    		if ($gal == get_gallery_name($galleries[$i])) {
	    			$del_file = $galleries[$i];
	    		}
	    		$i++;
	    	}
	    	if (delete_gallery($del_file)) {
	    		$setup .= "<tr><td align=\"center\"><a href=\"". get_link("plugin=edit") ."\"><b>".$lang['updated']."</b></a></td></tr>\n";
	    	} else {
	    		$setup .= "<tr><td align=\"center\"><a href=\"". get_link("plugin=edit") ."\"><b>".$lang['not_updated']."</b></a></td></tr>\n";
	    	}
		    // parse the template
			$out_array = array(
								"%setup%" => $lang['edit'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "3e":
			// setting the activity
		    $activity = $lang['moving'];
		    
		    if ($_POST['send_but'] == 1) {
		    	$cat = rawurldecode($_GET['cat']);
		    	$gals = list_all_dbs($gallery_path.$cat."/");
		    	$i = 0;$file = "";
		    	while ($i < count($gals)) {
		    		if (get_gallery_name($gals[$i]) == rawurldecode($_GET['gal'])) {
		    			$file = $gals[$i];
		    		}
		    		$i++;
		    	}
		    	$_file = explode("/",$file);
		    	$filename = $_file[count($_file)-1];
		    	// ok, now moving this file
		    	if (copy($file,$_POST['move_to'].$filename)) {
		    		if (unlink($file)) {
		    			$setup = "<tr><td align=\"center\"><b>".$lang['move_success']."</b><br><br><a href=\"". get_link("plugin=edit") ."\">".$lang['back']."</a></td></tr>\n";
		    		} else {
		    			unlink($_POST['move_to'].$filename);
		    			$setup = "<tr><td align=\"center\"><b>".$lang['move_no_success']."</b><br><br><a href=\"". get_link("plugin=edit") ."\">".$lang['back']."</a></td></tr>\n";
		    		}
		    	} else {
		    		$setup = "<tr><td align=\"center\"><b>".$lang['move_no_success']."</b><br><br><a href=\"". get_link("plugin=edit") ."\">".$lang['back']."</a></td></tr>\n";
		    	}
		    }
	    	// parse the template
			$out_array = array(
								"%setup%" => $lang['edit'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
	}
}

##### should the main script be stopped?
################################################################################
$stop = true;

?>
