<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This plugin will let you upload a zip- file and will  *|
 \*                   extract it on its own into the "tmp"- dir             *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 01.09.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: zip.inc.php                                  |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/

##### Code of the setup plugin
################################################################################
define("FS_GALERIE_PLUGIN_ZIP",$version);

// this script will never end...
// otherwise it is not possible to create large galleries, because of max_execution_time
@set_time_limit(0);

$setup = "<!-- Plugin: Zip Wizard for FS Galerie 2.x -->\n\n";
// first of all, let us collect all information send via POST
// this will not be done by the main file: common.inc.php, so we have to do it
if (!empty($_POST)) {
    extract_vars($_POST, $GLOBALS);
} else if (!empty($HTTP_POST_VARS)) {
    extract_vars($HTTP_POST_VARS, $GLOBALS);
}

// how many steps will this wizard have?
$steps = 2;

// just for control...
$exit = false;

// before we can start the steps, check whether we are logged in or not
// if so, a "session id" will get created automatically, if you use get_link(string get,[string file]) for all of your links!
login();

// check, if safe_mode is on or not
$safe_mode = (bool) ini_get("safe_mode");
if ($safe_mode) {
	$activity = "Zip is getting initialised...";
	$step = 0;
	$setup = "<tr><td align=\"center\">".$lang['safe_mode']."</td></tr>\n";
	$exit = true;
	$out_array = array(
						"%setup%" => $lang['setup'],
						"%url%" => get_link("plugin=admin"),
						"%img_url%" => $template_images_path,
				    	"%version%" => $version,
				    	"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    	"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    	"%step%" => $setup,
				    	"%error_msg%" => $lang['error_msg']
						);
	parse_template("setup.html",$out_array,0);
}

// check, whether there is everything, the wizard needs
if (!is_readable($tmp_path) || !is_writeable($tmp_path)) {
	$activity = "Zip is getting initialised...";
	$step = 0;
	$setup = "<tr><td align=\"center\">".$lang['config_error']."</td></tr>\n";
	$exit = true;
	$out_array = array(
						"%setup%" => $lang['zip'],
						"%url%" => get_link("plugin=admin"),
						"%img_url%" => $template_images_path,
				    	"%version%" => $version,
				    	"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    	"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    	"%step%" => $setup,
				    	"%error_msg%" => $lang['error_msg']
								);
	parse_template("setup.html",$out_array,0);
}

// now, start the steps, if logged in:
if (!$exit && $logged_in) {
	if (!isset($step) || empty($step)) {
		$step = 1;
	}
	// decide which step!
	switch($step) {
		case "1":
		    $activity = $lang['upload_zip_'];
		    
			$setup .= "<tr><td align=\"center\"><span class=\"error\"><b>". rawurldecode($msg) ."</b></span></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><form action=\"". get_link("plugin=zip&step=2") ."\" method=\"post\" enctype=\"multipart/form-data\"><input type=\"hidden\" name=\"upload\" value=\"true\"></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><b>".$lang['zip_upload_file'].":</b>&nbsp;&nbsp;<input type=\"file\" name=\"file\"></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"".$max_zipsize."\"><input type=\"submit\" name=\"submit\" value=\"".$lang['next']."\"></form></td></tr>\n";
        	
			// parse the template
			$out_array = array(
								"%setup%" => $lang['zip'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "2":
		    // include the zip- functions
		    include("./lib/pclzip.lib.php");
		    $activity = $lang['extract_zip'];

			// upload the zip archive
			if ($_POST['upload']) {
				$FILES = $_FILES;
				if (empty($FILES)) {
					$FILES = $HTTP_POST_FILES;
				}
				$uploaded_zip = 0;
				if (empty($FILES['file']['name'])) {
					@header("Location: ". get_link("plugin=zip&step=1&msg=". rawurlencode($lang['no_files_selected']) ) );
					exit();
				}
				
				if (($FILES['file']['size'] > 0) && ($FILES['file']['size'] <= $max_zipsize)) {
					$filemime = $FILES['file']['type'];
					if ($filemime == "application/x-zip-compressed" || $filemime == "application/octet-stream") {
						$file_expl = explode(".",$FILES['file']['name']);
						$ext = $file_expl[ count($file_expl)-1 ];
						if ($ext == "zip") {
							$move = @copy($FILES['file']['tmp_name'],$tmp_path.$FILES['file']['name']);
							if ($move) {
								$uploaded_zip++;
							}
						} else {
							@header("Location: ". get_link("plugin=zip&step=1&msg=". rawurlencode($lang['zip_wrong_mime']." ".$filemime) ) );
							exit();
						}
					} else {
						@header("Location: ". get_link("plugin=zip&step=1&msg=". rawurlencode($lang['zip_wrong_mime']." ".$filemime) ) );
						exit();
					}
				} else {
					@header("Location: ". get_link("plugin=zip&step=1&msg=". rawurlencode($lang['files_too_big']) ) );
					exit();
				}
				if ($uploaded_zip == 0) {
					@header("Location: ". get_link("plugin=zip&step=1&msg=". rawurlencode($lang['no_files_uploaded']) ) );
					exit();
				}
				$setup .= "<tr><td align=\"center\"><b>".$uploaded_zip." ".$lang['uploaded_text']."</b></td></tr>\n";
			}
			
			// now, extract the archive
			$ZIP = new PclZip($tmp_path.$FILES['file']['name']);
			if ($ZIP->extract(PCLZIP_OPT_PATH, $tmp_path) == 0) {
    			die("Error : ".$ZIP->errorInfo(true));
  			}
  			
  			// ok, everything is unzipped, so delete the archive
  			unlink($tmp_path.$FILES['file']['name']);
  			
  			// now, delete everything, that is not a picture
  			$image_ext = array("gif","jpg","jpeg","png");
    		$dir_handle = opendir($tmp_path);
    		while ($file = readdir($dir_handle)) {
        		if ($file != "." && $file != ".." && !is_dir($tmp_path.$file) && $file != ".htaccess" && $file != "index.html") {
            		$tmp_file = explode(".",$file);
            		$ext = strtolower($tmp_file[count($tmp_file)-1]);
            		$i = 0;
            		while ($i < count($image_ext)) {
                		if ($image_ext[0] != $ext && $image_ext[1] != $ext && $image_ext[2] != $ext && $image_ext[3] != $ext) {
							unlink($tmp_path.$file);
                		}
            			$i++;
            		}
        		}
    		}
    		closedir($dir_handle);
    		
    		// ok, only images (and other folders of the extracted archive) are left in tmp- dir
    		// so, start the setup wizard with option "files already uploaded"
            $setup .= "<tr><td align=\"center\"><a href=\"". get_link("plugin=setup") ."\">".$lang['zip_success']."</a></td></tr>\n";
            $setup .= "<tr><td align=\"center\"><br><br><a href=\"". get_link("plugin=admin") ."\">".$lang['zip_success_leave']."</a></td></tr>\n";
            
			// parse the template
			$out_array = array(
								"%setup%" => $lang['zip'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
	}
}

##### should the main script be stopped?
################################################################################
$stop = true;

?>
